

#include "pico/stdlib.h"
#include <stdio.h>
#include <math.h>

#include "pico/time.h"
#include "hardware/irq.h"
#include "hardware/structs/adc.h"
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_pwm\include\hardware\pwm.h>
//#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_adc\include\hardware\adc.h>
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_gpio\include\hardware\gpio.h>
//#include "hardware/adc.h"

#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_sync\include\hardware\sync.h>

#include "hardware/resets.h"
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_spi\include\hardware\spi.h>
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_spi\spi.c>



#define PWM_PIN1 2    // pin 4
#define PWM_PIN2 3    // pin 5
#define GPIO4 4     // pin 6    

/*
   GPIO 16 (pin 21) MISO
   GPIO 17 (pin 22) CS
   GPIO 18 (pin 24) SCK
   GPIO 19 (pin 25) MOSI
   GPIO 20 (pin 26) DC
   3.3v (pin 36) -> VCC
   GND (pin 38)  -> GND
*/

#define TFT_MISO 16 
#define TFT_CS 17 
#define TFT_SCK 18
#define TFT_MOSI 19 
#define TFT_DC 20 

int testFilter ;

#define ns 1e-9
#define us 1e-6
#define ms 1e-3


//-----------------------------------------------------------------------------------


//-----------------------------------------------------------------------------------

static void approxSleepUs(int n){
  for(int k=0 ; k<n ; k++){
    for( int kk=0 ; kk<24 ; kk++){
      asm volatile("nop");
      }
    }
  }
  
static void approxSleepMs(int n){
  for(int k=0 ; k<n ; k++){
    for( int kk=0 ; kk<10 ; kk++){
      approxSleepUs(100) ;
      }
    }
  }

static volatile void approxSleepUsTest(){
  printf("atleastSleepUsTest()\n") ;
  save_and_disable_interrupts() ;
  while(1){
    sio_hw->gpio_set =(1ul << GPIO4) ;  
	  approxSleepUs(1000) ;
    //sleep_ms(1) ;
    sio_hw->gpio_clr =(1ul << GPIO4) ;  
    approxSleepUs(1000) ;
  //  printf(".") ;
  }
} 

//-----------------------------------------------------------------------------------

int LOsinTab[4096] ;
int LOcosTab[4096] ;

uint32_t DDSp ; // DDS phase value
uint32_t DDSd ; // DDS phase delta

#define nSHDN 1 
#define nGA   1 


//-----------------------------------------------------------------------------------

#define maxsec 50 
#define maxfil 10 

#define IIRscale 16384  // must be 16384 for >>14 in iirfilter



int filtop=0 ;
int sectop=0  ;
int secstart[maxfil] ;
int seccnt[maxfil] ;


float a0[maxfil]  ;

float w1[maxsec] ;
float w2[maxsec] ;
float a1[maxsec] ;
float a2[maxsec] ;
float b1[maxsec] ;
float b2[maxsec] ;


int ia0[maxfil]  ;

int iw1[maxsec] ;
int iw2[maxsec] ;
int ia1[maxsec] ;
int ia2[maxsec] ;
int ib1[maxsec] ;
int ib2[maxsec] ;



int butter(int nord, float frq){
int i,nsec ; 
float a0x,eps,a,b,s1,s2,t,c1,w,ww,u,v,d ;

if ((nord % 2)!=0){ printf("nord wrong in Tscheby") ; }
filtop++ ;
if( filtop>maxfil){ printf("maxfil error") ; }
nsec=nord / 2 ;
secstart[filtop]=sectop+1 ;
seccnt[filtop]=nsec ;
printf("butterworth filter, no=%d\n",filtop) ;
printf("ord=%d number of sections is %d\n",nord,nsec) ;
a0x=1.0 ;
for( i=nord ; i< 3*nsec ; i++){
  t=(2.0*i+1.0)/(2.0*nord)*M_PI ;
  c1=M_PI*frq ;
  w=sin(c1)/cos(c1) ;
  printf("t=%10.4f  w=%10.4f\n",t,w) ;
  ww=w*w ;
  b=2*w ;
  d=1-b*cos(t)+ww ;
  u=(1-ww)/d ;
  v=b*sin(t)/d ;
  sectop++ ;
  b1[sectop]=-2*u ;
  b2[sectop]=u*u+v*v ;

  ib1[sectop]=IIRscale*(-2*u) ;
  ib2[sectop]=IIRscale*(u*u+v*v) ;


  printf("b1=%10.4f b2=%10.4f\n",b1[sectop],b2[sectop]) ;
  a1[sectop]=2 ; 
  a2[sectop]=1 ;

  ia1[sectop]=2 ; 
  ia2[sectop]=1 ;

  a0x=a0x*(1-2*u+u*u+v*v)/4 ;
  }
printf("a0=%10.4f\n",a0x) ;

a0[filtop]=a0x ;
ia0[filtop]=IIRscale*a0x ;
return filtop ;
}

void tpreset(int filno){ 
  int i ;
  printf("reset filter with no=%d\n",filno) ;
  for (i=secstart[filno] ; i<secstart[filno]+seccnt[filno] ; i++){
  w1[i]=0 ; 
  w2[i]=0 ; 
  iw1[i]=0 ; 
  iw2[i]=0 ; 
  printf("clear section %d\n",i) ;
  }
}

float tprun(int filno, float x){
  int i ; 
  float w,w11,w22,y ;
  //printf("IIRfilter float\n") ;
  for(i=secstart[filno] ; i< secstart[filno]+seccnt[filno] ; i++){
    //printf("i=%d\n",i) ;
    w11=w1[i] ; w22=w2[i] ;
    //printf("x=%10.3f w11=%10.3f w22=%10.3f\n",x,w11,w22) ;
    w=x-b1[i]*w11-b2[i]*w22 ;
    y=w+a1[i]*w11+a2[i]*w22 ;
    //printf("w=%10.3f y=%10.3f\n",w,y) ;
    w2[i]=w11 ; w1[i]=w ; x=y ;
    }
  return a0[filno]*y ;
  }

int itprun(int filno, int ix){
  int i ; 
  int iw,iw11,iw22,iy ;
  //printf("IIRfilter int\n") ;
  for(i=secstart[filno] ; i< secstart[filno]+seccnt[filno] ; i++){
    //printf("i=%d\n",i) ;
    iw11=iw1[i] ; iw22=iw2[i] ;
    //printf("ix=%10d iw11=%10d iw22=%10d\n",ix,iw11,iw22) ;
    iw=ix-(ib1[i]*iw11+ib2[i]*iw22)/IIRscale ;
    iy=iw+2*iw11+iw22 ;
    //printf("iw=%10d iy=%10d\n",iw,iy) ;
    iw2[i]=iw11 ; iw1[i]=iw ; ix=iy ;
    }
  return (ia0[filno]*iy)/IIRscale ;
  }

int itprun2(int filno, int ix){
  int i ; 
  int iw,iw11,iw22,iy ;
  //printf("IIRfilter int\n") ;
  //for(i=secstart[filno] ; i< secstart[filno]+seccnt[filno] ; i++){
    //printf("i=%d\n",i) ;
    iw11=iw1[1] ; iw22=iw2[1] ;
    //printf("ix=%10d iw11=%10d iw22=%10d\n",ix,iw11,iw22) ;
    iw=ix-(ib1[1]*iw11+ib2[1]*iw22)/IIRscale ;
    iy=iw+2*iw11+iw22 ;
    //printf("iw=%10d iy=%10d\n",iw,iy) ;
    iw2[1]=iw11 ; iw1[1]=iw ; ix=iy ;
    //}
  return (ia0[filno]*iy)/IIRscale ;
  }  


int iBW2b1 ;
int iBW2b2 ;
int iBW2a0 ;

void iBW2setup(float frq){
  float a0x,b,t,c1,d,w,ww,u,v ;
  printf("butterworth filter iBW2, frq=%10.3f\n",frq) ;
  a0x=1.0 ;
  int i=2 ;
  int nord=2 ;
  t=(2.0*i+1.0)/(2.0*nord)*M_PI ;
  c1=M_PI*frq ;
  w=sin(c1)/cos(c1) ;
  printf("t=%10.4f  w=%10.4f\n",t,w) ;
  ww=w*w ;
  b=2*w ;
  d=1-b*cos(t)+ww ;
  u=(1-ww)/d ;
  v=b*sin(t)/d ;
  iBW2b1=IIRscale*(-2*u) ;
  iBW2b2=IIRscale*(u*u+v*v) ;
  printf("b1=%10d b2=%10d\n",iBW2b1,iBW2b2) ;
  a0x=a0x*(1-2*u+u*u+v*v)/4 ;
  printf("a0=%10.4f\n",a0x) ;
  iBW2a0=IIRscale*a0x ;
  }

int iBW2w1 ;
int iBW2w2 ;

void iBW2reset(){ 
  iBW2w1=0 ; 
  iBW2w2=0 ; 
  }

int iBW2run(int ix){
  int iw,iy ;
/*  
  iw=ix-(iBW2b1*iBW2w1+iBW2b2*iBW2w2)/IIRscale ;
  iy=iw+2*iBW2w1+iBW2w2 ;
  iBW2w2=iBW2w1 ; iBW2w1=iw ; ix=iy ;
  return (iBW2a0*iy)/IIRscale ;
*/

  iw=ix-((iBW2b1*iBW2w1+iBW2b2*iBW2w2)>>14) ;
  iy=iw+2*iBW2w1+iBW2w2 ;
  iBW2w2=iBW2w1 ; iBW2w1=iw ; ix=iy ;
  return (iBW2a0*iy)>>14 ;

  }

//---------------------------------------------------------------

double fSample ;

void abort(){
  printf("abort..\n") ;
  printf("\n") ;
  while(1){} ;
  }

float x,y,sum ;
int ix,iy,isum ;
int iBW2y ;

int k ;

int main() {
  stdio_init_all();
  gpio_init(GPIO4);
  gpio_set_dir(GPIO4, GPIO_OUT);
  fSample=100000.0 ;
  DDSp =0 ;
  float DDSfrq=12.5e3 ;
  DDSd=(int)( 4294967296.0*DDSfrq/fSample) ;

  float frq=10.0/200.0 ;
  testFilter=butter(2,frq) ;
  iBW2setup(frq) ;
  tpreset(testFilter) ;
  iBW2reset() ;
  //abort() ;
  
  approxSleepMs(200);
  printf("//\n") ;
  printf("//\n") ;
  printf("Hello IRQloadMeasurementConsoleViaUartV02 !\n") ;

   for(int k=0 ; k<4096 ; k++){
    double phi=2*M_PI*k/4096.0 ;
    LOcosTab[k]=2045*cos(phi) ;
    LOsinTab[k]=2045*sin(phi) ;
   // printf("k=%8d LOsintab=%10d\n",k,LOsinTab[k]) ;
    }

  //abort() ;

 
  printf("Hello2\n") ;
  int k=0 ;
  printf("fSample=%15.5f\n",fSample) ;
 
  DDSp=0 ;
  for(int k=0 ; k<16 ; k++){
    printf("k=%3d DDS=%10d\n",k,LOsinTab[DDSp>>20]) ;
    DDSp += DDSd ; 
    }
  //abort() ; 

 
  // compare filter responses
  int s1=iBW2run(500) ;
  int s2=itprun(testFilter,500) ;
  float s3=tprun(testFilter,500.0) ;
  printf("s1=%8d  s2=%10d %12.3f \n",s1,s2,s3) ;
  for(int k=0 ; k<10 ; k++){
    s1=iBW2run(500) ; 
    s2=itprun(testFilter,500) ; 
    s3=tprun(testFilter,500.0) ;
    printf("s1=%8d  s2=%10d %12.3f \n",s1,s2,s3) ;
    }

// measure times in loop
  float x=0 ;
  float ss=0 ;
  int NN=1000 ;
  long long t1=time_us_64() ;
  for(int k=0 ; k<NN ; k++){
    ss += tprun(testFilter,x) ;
    x+=1.0 ;
    }
  long long t2=time_us_64() ;
  int dt1=(int) (t2-t1) ;
  printf("float IIR   t1=%lli t2=%lli t2-t1=%5d us (t2-t1)/NN=%10.3f ns\n",t1,t2,dt1,dt1/((float)NN)*us/ns) ;
  printf("s=%10.3f\n",ss) ;

  t1=time_us_64() ;
  int s=0 ;
  for(int k=0 ; k<NN ; k++){
    s += itprun(testFilter,k) ;
    }
  t2=time_us_64() ;
  int dt2=(int) (t2-t1) ;
  printf("int IIR     t1=%lli t2=%lli t2-t1=%5d us (t2-t1)/NN=%10.3f ns\n",t1,t2,dt2,dt2/((float)NN)*us/ns) ; 
  printf("s=%d\n",s) ;

 t1=time_us_64() ;
  s=0 ;
  for(int k=0 ; k<NN ; k++){
    s+=iBW2run(k) ;
    }
  t2=time_us_64() ;
  int dt3=(int) (t2-t1) ;
  printf("iBW2run IIR t1=%lli t2=%lli t2-t1=%5d us (t2-t1)/NN=%10.3f ns\n",t1,t2,dt3,dt3/((float)NN)*us/ns) ;
  printf("s=%d\n",s) ;


 


  printf("common test1\n") ;
  k=0 ;
  isum=0 ;
  while (1){
    DDSp += DDSd ; 
    ix=LOsinTab[DDSp>>20] ;
    gpio_put(GPIO4, 1);
    iy=iBW2run(ix) ;
    gpio_put(GPIO4, 0);
    approxSleepUs(1);  

    gpio_put(GPIO4, 1);
    iy=itprun(testFilter,ix) ;
    gpio_put(GPIO4, 0);
    approxSleepUs(1);  

    gpio_put(GPIO4, 1);
    y=tprun(testFilter,x) ;
    gpio_put(GPIO4, 0);
    approxSleepUs(100);  

    isum+=iy ;
    k++ ; if(k>=10001){ printf("sum=%10d\n",isum) ; isum=0 ; k=0 ;  }
    approxSleepUs(100);  
    }
  
  }

