#include "pico/stdlib.h"
#include <stdio.h>
#include <math.h>

#include "pico/time.h"
#include "hardware/irq.h"
#include "hardware/structs/adc.h"
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_adc\include\hardware\adc.h>
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_gpio\include\hardware\gpio.h>
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_sync\include\hardware\sync.h>
#include "hardware/resets.h"

//-----------------------------------------------------------------------------------

#define tftOn 1

// Color definitions
#define ILI9341_BLACK       0x0000      /*   0,   0,   0 */
#define ILI9341_NAVY        0x000F      /*   0,   0, 128 */
#define ILI9341_DARKGREEN   0x03E0      /*   0, 128,   0 */
#define ILI9341_DARKCYAN    0x03EF      /*   0, 128, 128 */
#define ILI9341_MAROON      0x7800      /* 128,   0,   0 */
#define ILI9341_PURPLE      0x780F      /* 128,   0, 128 */
#define ILI9341_OLIVE       0x7BE0      /* 128, 128,   0 */
#define ILI9341_LIGHTGREY   0xC618      /* 192, 192, 192 */
#define ILI9341_DARKGREY    0x7BEF      /* 128, 128, 128 */
#define ILI9341_BLUE        0x001F      /*   0,   0, 255 */
#define ILI9341_GREEN       0x07E0      /*   0, 255,   0 */
#define ILI9341_CYAN        0x07FF      /*   0, 255, 255 */
#define ILI9341_RED         0xF800      /* 255,   0,   0 */
#define ILI9341_MAGENTA     0xF81F      /* 255,   0, 255 */
#define ILI9341_YELLOW      0xFFE0      /* 255, 255,   0 */
#define ILI9341_WHITE       0xFFFF      /* 255, 255, 255 */
#define ILI9341_ORANGE      0xFD20      /* 255, 165,   0 */
#define ILI9341_GREENYELLOW 0xAFE5      /* 173, 255,  47 */
#define ILI9341_PINK        0xF81F

int chrColor = ILI9341_WHITE ; 
int chrBackground = ILI9341_BLACK ; 
int xLast=0 ;
int yLast=0 ;

#include "tftLib1.c"

//-----------------------------------------------------------------------------------

double rr,gg,bb ;

void spectral_color(double l) // RGB <0,1> <- lambda l <400,700> [nm]
    {
    double t;  rr=0.0; gg=0.0; bb=0.0;
         if ((l>=400.0)&&(l<410.0)) { t=(l-400.0)/(410.0-400.0); rr=    +(0.33*t)-(0.20*t*t); }
    else if ((l>=410.0)&&(l<475.0)) { t=(l-410.0)/(475.0-410.0); rr=0.14         -(0.13*t*t); }
    else if ((l>=545.0)&&(l<595.0)) { t=(l-545.0)/(595.0-545.0); rr=    +(1.98*t)-(     t*t); }
    else if ((l>=595.0)&&(l<650.0)) { t=(l-595.0)/(650.0-595.0); rr=0.98+(0.06*t)-(0.40*t*t); }
    else if ((l>=650.0)&&(l<700.0)) { t=(l-650.0)/(700.0-650.0); rr=0.65-(0.84*t)+(0.20*t*t); }
         if ((l>=415.0)&&(l<475.0)) { t=(l-415.0)/(475.0-415.0); gg=             +(0.80*t*t); }
    else if ((l>=475.0)&&(l<590.0)) { t=(l-475.0)/(590.0-475.0); gg=0.8 +(0.76*t)-(0.80*t*t); }
    else if ((l>=585.0)&&(l<639.0)) { t=(l-585.0)/(639.0-585.0); gg=0.84-(0.84*t)           ; }
         if ((l>=400.0)&&(l<475.0)) { t=(l-400.0)/(475.0-400.0); bb=    +(2.20*t)-(1.50*t*t); }
    else if ((l>=475.0)&&(l<560.0)) { t=(l-475.0)/(560.0-475.0); bb=0.7 -(     t)+(0.30*t*t); }
    }
    
void spectral_color2(double w) // RGB <0,1> <- lambda l <400,700> [nm]
    {
if (w >= 380 & w < 440){ rr = -(w - 440.) / (440. - 380.) ; gg = 0.0 ; bb = 1.0 ; }
else if( w >= 440 & w < 490){ rr = 0.0 ; gg = (w - 440.) / (490. - 440.) ; bb = 1.0 ; }
else if( w >= 490 & w < 510 ){ rr = 0.0 ; gg = 1.0 ; bb = -(w - 510.) / (510. - 490.) ; }
else if( w >= 510 & w < 580){ rr = (w - 510.) / (580. - 510.) ; gg = 1.0 ; bb = 0.0 ; }
else if( w >= 580 & w < 645){ rr = 1.0 ; gg = -(w - 645.) / (645. - 580.) ; bb = 0.0 ; }
else if( w >= 645 & w <= 780){ rr = 1.0 ; gg = 0.0 ; bb = 0.0 ; }
else{ rr = 0.0 ; gg = 0.0 ; bb = 0.0 ; }
    }






void spectralTest(){
    double lambda ;
  for(int x=0 ; x<300 ; x++){
    lambda=400+x ;
    spectral_color2(lambda) ;
    tftRectf(x,50,1,20,rgb(255*rr,255*gg,255*bb)) ;
    }
  }    
//--------------------------------------------------------------------------




int main(){
  stdio_init_all();

  puts("Hello, world!");
  tftSetup() ;
  Rectf(10,10,100,100,0xF800) ;
  Rectf(10,110,100,100,0x07E0) ;
  Rectf(10,210,100,100,0x001F) ;
  //RectfOld(110,10,100,100,0xF800) ;
  //RectfOld(110,110,100,100,0x07E0) ;
  //RectfOld(110,210,100,100,0x001F) ;

  tftLine(0,0,320,320,0xF800) ; 
  tftLine(0,320,320,0,0xF800) ; 

  int x=10 ; 
  int y=150 ; 
  int chr='A' ;
  while(x<400){
    tftChr(x,y,chr) ;
    x+=Cols ; chr++ ;
  
    }
  cursorX=200 ; cursorY=100 ; tftPrint("Hello World!") ;
//  colorTest() ;
   for(int k=0 ; k<60 ; k++){
     drawChr8x6('A'+k,6*k, 180) ;
     }

    for(int k=0 ; k<20 ; k++){
     drawChr6x8('A'+k,8*k, 200) ;
     }


   spectralTest() ;  
  return 0;
}
