
#include "pico/stdlib.h"
#include <stdio.h>
#include <math.h>

#include "pico/time.h"
#include "hardware/irq.h"
#include "hardware/structs/adc.h"
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_adc\include\hardware\adc.h>
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_gpio\include\hardware\gpio.h>
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_sync\include\hardware\sync.h>
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_pwm\include\hardware\pwm.h>
#include "hardware/resets.h"

#define PWM_PIN1 2    // pin 4
//#define PWM_PIN2 3    // pin 5
#define GPIO4 4     // pin 6    

void restore_interrupts 	( 	uint32_t  	status	) 	;
uint32_t save_and_disable_interrupts 	( 	void  		) ;	

// adc input adc2= GPIO28 pin 34

int toggle ;

float fSample,tSample ;

#define nSamples 480     // Anzahl der Messpunkte 
#define nDown 1          // Abtastrate ist 100kHz/nDown 
#define yScale 1         // Multiplikator y Wert
#define withTrigger 1    // getriggert (1) oder freilaufend (0)
#define triggerLevel 0   // Triggerschwelle (pos Flanke)
#define timeOut 1000     // nach soviel Samples wird zwangsgetriggert   
#define printLimit 20    // soviel Messwerte werden per RS232 angezeigt
#define ACcouple 0       // =1: Subtrahiere DC-offset
#define offset1 0        // Anzeige y-Verschiebung Kanal 1
#define offset2 0        // Anzeige y-Verschiebung Kanal 2


//-----------------------------------------------------------------------------------

#define tftOn 1

// Color definitions
#define ILI9341_BLACK       0x0000      /*   0,   0,   0 */
#define ILI9341_NAVY        0x000F      /*   0,   0, 128 */
#define ILI9341_DARKGREEN   0x03E0      /*   0, 128,   0 */
#define ILI9341_DARKCYAN    0x03EF      /*   0, 128, 128 */
#define ILI9341_MAROON      0x7800      /* 128,   0,   0 */
#define ILI9341_PURPLE      0x780F      /* 128,   0, 128 */
#define ILI9341_OLIVE       0x7BE0      /* 128, 128,   0 */
#define ILI9341_LIGHTGREY   0xC618      /* 192, 192, 192 */
#define ILI9341_DARKGREY    0x7BEF      /* 128, 128, 128 */
#define ILI9341_BLUE        0x001F      /*   0,   0, 255 */
#define ILI9341_GREEN       0x07E0      /*   0, 255,   0 */
#define ILI9341_CYAN        0x07FF      /*   0, 255, 255 */
#define ILI9341_RED         0xF800      /* 255,   0,   0 */
#define ILI9341_MAGENTA     0xF81F      /* 255,   0, 255 */
#define ILI9341_YELLOW      0xFFE0      /* 255, 255,   0 */
#define ILI9341_WHITE       0xFFFF      /* 255, 255, 255 */
#define ILI9341_ORANGE      0xFD20      /* 255, 165,   0 */
#define ILI9341_GREENYELLOW 0xAFE5      /* 173, 255,  47 */
#define ILI9341_PINK        0xF81F

int chrColor = ILI9341_WHITE ; 
int chrBackground = ILI9341_BLACK ; 
int xLast=0 ;
int yLast=0 ;

//-----------------------------------------------------------------------------------

static void approxSleepUs(int n){
  for(int k=0 ; k<n ; k++){
    for( int kk=0 ; kk<5 ; kk++){
      asm volatile("nop");
      }
    }
  }
  
static void approxSleepMs(int n){
  for(int k=0 ; k<n ; k++){
    for( int kk=0 ; kk<10 ; kk++){
      approxSleepUs(1000) ;
      }
    }
  }

static volatile void approxSleepUsTest(){
  printf("atleastSleepUsTest()\n") ;
  save_and_disable_interrupts() ;
  while(1){
    sio_hw->gpio_set =(1ul << GPIO4) ;  
	  approxSleepUs(1000) ;
    //sleep_ms(1) ;
    sio_hw->gpio_clr =(1ul << GPIO4) ;  
    approxSleepUs(1000) ;
  //  printf(".") ;
  }
} 

#include "tftLib1.c"
#include "graphTerm1.c"

int scopeTrace1[nSamples] ;
int scopeTrace2[nSamples] ;

//------------------------------------------------------------------------------------------------------

void adc_initNew(void) {
    // ADC is in an unknown state. We should start by resetting it
    reset_block(RESETS_RESET_ADC_BITS);
    unreset_block_wait(RESETS_RESET_ADC_BITS);
    // Now turn it back on. Staging of clock etc is handled internally
    adc_hw->cs = ADC_CS_EN_BITS;
    // Internal staging completes in a few cycles, but poll to be sure
    while (!(adc_hw->cs & ADC_CS_READY_BITS)) {
        tight_loop_contents();
    }
}

void adcTest(){
  int v1=0 ;
  int v2=0 ;
  printf("\nADCtest()...\n") ;
  while(1){
    adc_select_input(1);
    v1=adc_read()-2048;
    adc_select_input(2);
    v2=adc_read()-2048;
    printf("adc1-2048=%8d adc2-2048=%8d\n",v1,v2) ;
    sleep_ms(250) ;
    }
  }

//----------------------------------------------------------------------------------------  
//----------------------------------------------------------------------------------------  

int nn=0 ;
volatile int scopePtr=0 ;

void on_pwm_wrap(){ // approx 6.5us
  gpio_put(GPIO4, 1);
  pwm_clear_irq(pwm_gpio_to_slice_num(PWM_PIN1));
  //printf("!") ;
  if(nn<nDown){
    nn++ ;
    }
   else{ 
    if(scopePtr<nSamples){
      adc_select_input(1);
      scopeTrace1[scopePtr]=adc_read() ;
      adc_select_input(2);
      scopeTrace2[scopePtr]=adc_read();
      scopePtr++ ;
      nn=1 ;
      }
    }
  gpio_put(GPIO4, 0);  
  }

void on_pwm_wrap2(){
  pwm_clear_irq(pwm_gpio_to_slice_num(PWM_PIN1));
  }  

int sample(){
  adc_select_input(2) ;
  int v=adc_read()-2048 ;
 // printf("v=%8d\n",v) ;
  return v ;
  }

void trigger(){
  int lastSample,thisSample ;
  long timer ;
  if(!withTrigger) return ;
  lastSample=sample() ;
  thisSample=sample() ;
  timer=0 ;
 // printf("wait for trigger\n") ;
  while(1){
    if( (lastSample<=triggerLevel) & (thisSample>=triggerLevel) ) { 
      //printf("trigger found\n") ;
      return ; 
      }
    lastSample=thisSample ;
    thisSample=sample() ;
    timer++ ;
    if(timeOut>0){
      if(timer>=timeOut) { return ; }
      }
    }
  }

void getDummy(){
  while(1){
    scopePtr=0 ;
    pwm_clear_irq(pwm_gpio_to_slice_num(PWM_PIN1));
    while(scopePtr<nSamples){ } ;
    }
  }

void getBuffer() {
  uint32_t state ;
  int adc ;
  state=save_and_disable_interrupts () ;
  scopePtr=0 ;
  trigger() ; 
  pwm_clear_irq(pwm_gpio_to_slice_num(PWM_PIN1));
  restore_interrupts (state) ;
  while(scopePtr<nSamples){ } ;
  for(int j=0 ; j<printLimit ; j++){
    printf("j=%5d adc1=%8d    adc2=%8d\n",j,scopeTrace1[j],scopeTrace2[j]) ;
    }
  float mean1=0 ;
  float mean2=0 ;
  for (int k = 0; k < nSamples ; k++ ){
    scopeTrace1[k]=scopeTrace1[k]-2048+offset1 ;
    scopeTrace2[k]=scopeTrace2[k]-2048+offset2 ;
    mean1 += scopeTrace1[k] ;
    mean1 += scopeTrace1[k] ;
    }
  mean1=mean1/(nSamples) ;
  mean2=mean2/(nSamples) ;
  if(ACcouple){
    for (int k = 0; k < nSamples ; k++ ){
      scopeTrace1[k] -= mean1 ;
      scopeTrace2[k] -= mean2;
      }
    }
  for(int j=0 ; j<printLimit ; j++){
    printf("j1=%5d adc1=%8d    adc2=%8d\n",j,scopeTrace1[j],scopeTrace2[j]) ;
    }
  }
  
int yFun(int y){
  return (int) ( tftHeight/2+y/4096.0*tftHeight) ;
  }  

int voltsToY(float v){
  int y=(int)( tftHeight/2+tftHeight/2*v*yScale/(3.3/2.0)) ;
  return y ;
  }

int kToTFT(int k){
  return tftWidth*k/((float)nSamples) ;
  }

#define us 1e-6

int timeToK(float t){
  return (int)( t/tSample) ;
  }

float adcToVolts(float a){
  return 3.3/2.0*a/yScale/2048.0 ;
  }  

float sqr(float x){ return x*x ; }

float kToGraph(int k){
  return dd+(xSize-2*dd)*((float)k)/((float)nSamples) ;
  }

float yTFTtoGraph(int y){
  return dd+(ySize-2*dd)-(ySize-2*dd)*y/((float)tftHeight) ;
  }

void showScope(){
  int m=5 ;
  int tftDisplay=1 ;
  if(tftDisplay){
    int y=voltsToY(0.0) ; brokenLine(0,y,tftWidth,y,m,ILI9341_GREEN) ;
    y=voltsToY(0.5) ; brokenLine(0,y,tftWidth,y,m,ILI9341_GREEN) ;
    y=voltsToY(-0.5) ; brokenLine(0,y,tftWidth,y,m,ILI9341_GREEN) ;
    y=voltsToY(1) ; brokenLine(0,y,tftWidth,y,m,ILI9341_GREEN) ;
    y=voltsToY(-1) ; brokenLine(0,y,tftWidth,y,m,ILI9341_GREEN) ;

    int x=timeToK(0) ; brokenLine(x,0,x,tftHeight,m,ILI9341_GREEN) ;
    
 float ms=1e-3 ;
    x=kToTFT(timeToK(1*ms)) ; brokenLine(x,0,x,tftHeight,m,ILI9341_GREEN) ;
    cursorX=kToTFT(timeToK(1*ms)) ;  cursorY=(tftHeight/2-20) ; tftPrint("1ms") ;

    //x=kToTFT(timeToK(250*us)) ; brokenLine(x,0,x,tftHeight,m,ILI9341_GREEN) ;
    //cursorX=kToTFT(timeToK(250*us)) ;  cursorY=(tftHeight/2-20) ; tftPrint("250us") ; 

    //x=kToTFT(timeToK(500*us)) ; brokenLine(x,0,x,tftHeight,m,ILI9341_GREEN) ;
    //cursorX=kToTFT(timeToK(500*us)) ;  cursorY=(tftHeight/2-20) ; tftPrint("500us") ; 

    //x=kToTFT(timeToK(750*us)) ; brokenLine(x,0,x,tftHeight,m,ILI9341_GREEN) ;
    //cursorX=kToTFT(timeToK(750*us)) ;  cursorY=(tftHeight/2-20) ; tftPrint("750us") ;

    cursorX=2 ; cursorY=tftHeight-20 ; tftPrint("Volt") ; 
    cursorX=2 ; cursorY=voltsToY(0.5)-10 ; tftPrint("+0.5") ; 
    cursorX=2 ; cursorY=voltsToY(1.0)-10 ; tftPrint("+1.0") ; 
    cursorX=2 ; cursorY=voltsToY(0)-10 ; tftPrint("0") ; 
    cursorX=2 ; cursorY=voltsToY(-0.5)-10 ; tftPrint("-0.5") ; 
    cursorX=2 ; cursorY=voltsToY(-1.0)-10 ; tftPrint("-1.0") ; 
        
   // cursorX=xScale*timeToK(910*us) ;  cursorY=(tftHeight/2-20) ; tftPrint("us") ;
    for(int k=1 ; k<nSamples ; k++){
      tftLine( kToTFT(k-1), yFun(scopeTrace1[k-1]) ,kToTFT(k),yFun(scopeTrace1[k]),rgb(0,100,255)) ;
      }
    for(int k=1 ; k<nSamples ; k++){
      tftLine( kToTFT(k-1), yFun(scopeTrace2[k-1]) ,kToTFT(k),yFun(scopeTrace2[k]),rgb(0,255,0)) ;
      }
    }
  
  int graphDisplay=1 ;  
  if(graphDisplay){
    printf("B\n") ; sleep_ms(100) ;
    printf("H16;\n") ;
    printf("W2;\n") ;
    printf("M10;25;\n") ; printf("T%cgraphTerm 1.0%c\n",'"','"') ;
    float endTime=nSamples*tSample ;
    printf("M200;25;") ; printf("T%cendT=%8.1f us%c",'"',endTime/1e-6,'"') ;
    graphFrame() ;

    char sbuf[200] ;
    sprintf(sbuf,"endT=%8.1f us",endTime/1e-6) ;
    cursorX=200 ; cursorY=tftHeight-20 ; tftPrint(sbuf) ; 

    int y=voltsToY(0.0) ;
    BLine(dd,yTFTtoGraph(y),xSize-dd,yTFTtoGraph(y),15 ) ;
    MMove(dd+5,yTFTtoGraph(y)-5 ) ;
    TText("0.0 V") ;

    y=voltsToY(0.5) ;
    BLine(dd,yTFTtoGraph(y),xSize-dd,yTFTtoGraph(y),15 ) ;
    MMove(dd+5,yTFTtoGraph(y)-5 ) ;
    TText("0.5 V") ;

    y=voltsToY(-0.5) ;
    BLine(dd,yTFTtoGraph(y),xSize-dd,yTFTtoGraph(y),15 ) ;
    MMove(dd+5,yTFTtoGraph(y)-5 ) ;
    TText("-0.5 V") ;

    y=voltsToY(1) ; 
    BLine(dd,yTFTtoGraph(y),xSize-dd,yTFTtoGraph(y),15 ) ;
    MMove(dd+5,yTFTtoGraph(y)-5 ) ;
    TText("1.0 V") ;

    y=voltsToY(-1) ;
    BLine(dd,yTFTtoGraph(y),xSize-dd,yTFTtoGraph(y),15 ) ;
    MMove(dd+5,yTFTtoGraph(y)-5 ) ;
    TText("-1.0 V") ;

    int x=timeToK(0) ;
    BLine(kToGraph(x),dd,kToGraph(x),ySize-dd,15) ;

/*
    x=kToGraph(timeToK(250*us)) ; 
    BLine(kToGraph(x),dd,kToGraph(x),ySize-dd,15) ;
    MMove(kToGraph(x),yTFTtoGraph(voltsToY(0.01) ) ) ;
    TText("250us") ;

    x=kToGraph(timeToK(500*us)) ; 
    BLine(kToGraph(x),dd,kToGraph(x),ySize-dd,15) ;
    MMove(kToGraph(x),yTFTtoGraph(voltsToY(0.01) ) ) ;
    TText("500us") ;

    x=kToGraph(timeToK(750*us)) ;
    BLine(kToGraph(x),dd,kToGraph(x),ySize-dd,15) ;
    MMove(kToGraph(x),yTFTtoGraph(voltsToY(0.01) ) ) ;
    TText("750us") ;
*/
    SStroke(0,250,0) ;
    for(int k=0 ; k<nSamples ; k++){
      if(k==0){ MMove(kToGraph(k),yTFTtoGraph(yFun(scopeTrace1[k])) ) ; }
       else { DDraw(kToGraph(k),yTFTtoGraph(yFun(scopeTrace1[k])) ) ; }
      }
    SStroke(250,100,0) ;  
    for(int k=0 ; k<nSamples ; k++){
      if(k==0){ MMove(kToGraph(k),yTFTtoGraph(yFun(scopeTrace2[k])) ) ; }
       else { DDraw(kToGraph(k),yTFTtoGraph(yFun(scopeTrace2[k])) ) ; }
      }
    }
  
  for(int k=0 ; k<nSamples ; k++){  
    if(k<printLimit){
      printf("%5d :: %8d    %8d\n",k,scopeTrace1[k],scopeTrace2[k]) ;
      }
    }
    
  //printf("fSample=%10.1f Hz\n",fSample) ;
  float vMean1=0.0 ;
  float vMax1=-1e5 ;
  float vMin1=1e5 ;
  float vRMS1=0.0 ;

  float vMean2=0.0 ;
  float vMax2=-1e5 ;
  float vMin2=1e5 ;
  float vRMS2=0.0 ;

  for(int k=0 ; k<nSamples ; k++){
    float v1=adcToVolts(scopeTrace1[k]) ;
    vMean1 += v1 ;
    if(v1>vMax1){ vMax1=v1 ; }
    if(v1<vMin1){ vMin1=v1 ; }
    vRMS1+=sqr(v1) ;

    float v2=adcToVolts(scopeTrace2[k]) ;
    vMean2 += v2 ;
    if(v2>vMax2){ vMax2=v2 ; }
    if(v2<vMin2){ vMin2=v2 ; }
    vRMS2+=sqr(v2) ;

    }
  vRMS1=sqrt(vRMS1/nSamples) ;
  vMean1=vMean1/nSamples ; 
  
  vRMS2=sqrt(vRMS2/nSamples) ;
  vMean2=vMean2/nSamples ; 

  char sbuf[200] ;  
  sprintf(sbuf,"Vmean1=%10.4f V",vMean1) ; printf("R%c%s%c\n",'"',sbuf,'"') ;
  sprintf(sbuf,"Vrms1 =%10.4f V",vRMS1) ; printf("R%c%s%c\n",'"',sbuf,'"') ;
  sprintf(sbuf,"Vmax1 =%10.4f V",vMax1) ; printf("R%c%s%c\n",'"',sbuf,'"') ;
  sprintf(sbuf,"Vmin1 =%10.4f V",vMin1) ; printf("R%c%s%c\n",'"',sbuf,'"') ;
  sprintf(sbuf,"Vpp1  =%10.4f V",vMax1-vMin1) ; printf("R%c%s%c\n",'"',sbuf,'"') ;

  sprintf(sbuf,"Vmean2=%10.4f V",vMean2) ; printf("R%c%s%c\n",'"',sbuf,'"') ;
  sprintf(sbuf,"Vrms2 =%10.4f V",vRMS2) ; printf("R%c%s%c\n",'"',sbuf,'"') ;
  sprintf(sbuf,"Vmax2 =%10.4f V",vMax2) ; printf("R%c%s%c\n",'"',sbuf,'"') ;
  sprintf(sbuf,"Vmin2 =%10.4f V",vMin2) ; printf("R%c%s%c\n",'"',sbuf,'"') ;
  sprintf(sbuf,"Vpp2  =%10.4f V",vMax2-vMin2) ; printf("R%c%s%c\n",'"',sbuf,'"') ;
  }

int adc_read2(void) {
    hw_set_bits(&adc_hw->cs, ADC_CS_START_ONCE_BITS);
    while (!(adc_hw->cs & ADC_CS_READY_BITS)){}
       
    return adc_hw->result;
    }

void showBuffer(){
  // fillRectOssi2(0, 0, xSize, ySize, ILI9341_BLACK ) ;
  printf("\nshowBuffer()...\n") ;
  getBuffer() ;
  tftClear(ILI9341_BLACK ) ;
  tftLine(0,0,0,320,ILI9341_WHITE) ;
  showScope() ; 
  approxSleepMs(2000) ;
  }  

//----------------------------------------------------------------------------------------  

void PWMsetup(){    
  gpio_set_function(PWM_PIN1, GPIO_FUNC_PWM);
  // Figure out which slice we just connected to the pin
  uint slice_num1 = pwm_gpio_to_slice_num(PWM_PIN1);
  // Mask our slice's IRQ output into the PWM block's single interrupt line,
  // and register our interrupt handler

 
  // Get some sensible defaults for the slice configuration. 
  pwm_config config1 = pwm_get_default_config();
  // Set divider, reduces counter clock to sysclock/this value
  pwm_config_set_clkdiv(&config1, 1.f);
  pwm_config_set_output_polarity (&config1,1,0) ; // invert A channel
  // Load the configuration into our PWM slice, and set it running.
  pwm_init(slice_num1, &config1, true);
  // Set period of 125 cycles (0 to 124 inclusive)
  //pwm_set_wrap(slice_num1,124 );
  #define clkDiv 1250
  pwm_set_wrap(slice_num1,(clkDiv-1) );
  float fPWMirq=125e6/clkDiv/1.0 ;
  printf("fPWMirq=%15.5f\n",fPWMirq) ;
  printf("PWM_PIN1=%d\n",PWM_PIN1) ;
  printf("slice_num1=%d\n",slice_num1) ;
  pwm_set_gpio_level(PWM_PIN1, 500);
  printf("\n") ;
  if(1){
    pwm_clear_irq(slice_num1);
    pwm_set_irq_enabled(slice_num1, true);
    irq_set_exclusive_handler(PWM_IRQ_WRAP, on_pwm_wrap);
    irq_set_enabled(PWM_IRQ_WRAP, true);
    printf("\nPWM irq enabled!\n") ;
    }
  }


//----------------------------------------------------------------------------------------  

int main() {
  stdio_init_all();
  gpio_init(GPIO4);
  gpio_set_dir(GPIO4, GPIO_OUT);
  sleep_ms(250) ;
  printf("\n\n") ;
  printf("Hello DualScope3p5TFTwithHardwareUartV01\n") ;

// Select ADC input 2 (GPIO28)
  adc_gpio_init(27);
  adc_gpio_init(28);
  adc_select_input(2) ;
  adc_initNew();
  PWMsetup() ;
  fSample=125e6/clkDiv/nDown ;
  tSample=1.0/fSample ;
  printf("fSample=%15.5f\n",fSample) ;
 
  tftSetup() ;
 
  approxSleepMs(200);
  printf("//\n") ;
  printf("//\n") ;
  printf("Hello ... !\n") ;
  
  toggle=0 ;
  while (1){
    showBuffer() ;
    }
  }

