
//---------------------------------------------------------------------------------------   
import processing.serial.*;
String portName="COM2" ;
Serial myPort;       

final int CR=13 ;
final int LF=10 ;

boolean isNum(char c){
  if (c<'0') return false ;
  if (c>'9') return false ;
  return true ;
  }

volatile int m ;

char getChar(){
  char c ;
   while (myPort.available()<=0) { 
     m++ ;
     } ;
   c=(char) myPort.read() ;
//   print(c) ;
   return c ;
  }
    
//---------------------------------------------------------------------------------------     
   
int xSize=1000 ;
int ySize=800 ;

void settings(){
  size(xSize, ySize, P3D);
  }
   
void setup(){
  println("Setup()....") ;
  myPort = new Serial(this, portName, 115200);
  background(0) ;
  strokeWeight(2) ;
  stroke(255,255,255) ;
  textSize(16) ;
  }


//----------------------------------------------------------------------------------------

void MMove(int xx,int yy){
  xPos=xx ; yPos=yy ;
  }
  
void DDraw(int xx, int yy){  
 line(xPos,yPos,xx,yy) ; xPos=xx ; yPos=yy ;
  }

void LLine(int xx1, int yy1, int xx, int yy){  
 line(xx1,yy1,xx,yy) ;
 xPos=xx ; yPos=yy ; 
  }
  
void SStroke(int rr, int gg, int bb){
  stroke(rr,gg,bb) ;
  }
  
void TText(String tt){
  fill(255,255,0) ;
  text(tt,xPos,yPos) ;  
  }

void brokenLine(int xx0, int yy0, int xx1 , int yy1, int m){
  int x,y,dx,dy,d,xss,yss ;
  int toggle,toggleCnt ;
  x=xx0 ; y=yy0 ;
  toggleCnt=0 ;
  toggle=1 ;
  point(x,y) ;
  dy=yy1-yy0 ; if (dy<0) {dy=-dy ; }
  dx=xx1-xx0 ; if (dx<0) {dx=-dx ; } 
  d=dx-dy ;
  if (xx1>xx0) { xss=1 ; } else { xss=-1 ; } ;
  if (yy1>yy0) { yss=1 ; } else { yss=-1 ; } ;
  while ( (x!=xx1) || (y!=yy1) ) {
    if (d>=0){ x += xss ; d -=dy ; }
    if (d<0) { y+=yss ; d+=dx ; }
    if(toggle==1){  point(x,y) ; }
    toggleCnt++ ;
    if(toggleCnt>=m){ toggleCnt=0 ; toggle=1-toggle ; }
    }     
    
  }

//----------------------------------------------------------------------------------------

//int dd=5 ;
//int phSize=200 ;
//int ee=ySize-phSize ;

//----------------------------------------------------------------------------------------

String getPar(){
  char c ;
  String s="" ;
  do{ c=getChar() ; s=s+c ; } while(c!=';') ;
  //print("["+s+"]") ;
  return s ;
  }

String getVar(char cc){
  char c ;
  do{ c=getChar() ; } while(c!=cc) ;
  c=getChar() ;
  if(c!=':'){ println("format error1") ; }
  return getPar() ;
  }

int scanInt(String s){
  int val=0 ;
  int sign=1 ;
  for(int k=0 ; k<s.length() ; k++){
    char c=s.charAt(k) ;
    if(c=='-'){ sign=-1 ; }
    if(('0'<=c)&(c<='9')){
      val=10*val+c-'0' ;
      }
    }
  return sign*val ;  
  }
  
float scanFloat(String s){
  float val=0 ;
  int sign=1 ;
  int behindDp=0 ;
  float scale=1.0 ;
  for(int k=0 ; k<s.length() ; k++){
    char c=s.charAt(k) ;
    if(c=='-'){ sign=-1 ; }
    if(c=='.'){ behindDp=1 ; scale=0.1 ; }
    if(('0'<=c)&(c<='9')){
      if(behindDp==0){ val=10*val+c-'0' ;} else { val=val+scale*(c-'0') ;  scale=scale*0.1 ; behindDp++ ; }
      }
    }
  return sign*val ;  
  }

int xx,yy ;
int rr,gg,bb ;
int xPos,yPos ;

void getXXYY(){
  String sx=getPar() ;
  xx=scanInt(sx) ;
  String sy=getPar() ;
  yy=scanInt(sy) ;
}

void getRRGGBB(){
  String sr=getPar() ;
  rr=scanInt(sr) ;
  String sg=getPar() ;
  gg=scanInt(sg) ;
  String sb=getPar() ;
  bb=scanInt(sb) ;
}

void skipTo(char cc){
  char c ;
  do{ c=getChar() ;
    } while(c!=cc) ;
  }

void execText(){
  char c;
  println("execText") ;
  skipTo('"') ;
  String s="" ;
  do{ c=getChar() ; if(c!='"') { s=s+c ; } 
    } while (c!='"') ;
  print("text=[[") ; print(s) ; println("]]") ;
  fill(255,255,0) ;
  text(s,xPos,yPos) ;  
  println("end execText") ;
  }

void execLine(){
  getXXYY() ; 
  xPos=xx ; 
  yPos=yy ; 
  getXXYY() ; 
  line(xPos,yPos,xx,yy) ;
 // println("LINE(",xPos,",",yPos,",",xx,",",yy,")") ;
  xPos=xx ; yPos=yy ;
  }
  
void execBLine(){
  getXXYY() ; 
  xPos=xx ; 
  yPos=yy ; 
  getXXYY() ; 
  String mm=getPar() ;
  int m=scanInt(mm) ;
  brokenLine(xPos,yPos,xx,yy,m) ;
 // println("LINE(",xPos,",",yPos,",",xx,",",yy,")") ;
  xPos=xx ; yPos=yy ;
  }  

void execCircle(){
  String cc=getPar() ;
  rr=scanInt(cc) ;
  circle(xPos,yPos,rr) ;
  }

void execChar(){
  char c=getChar() ;
  if(c=='M'){ getXXYY() ; xPos=xx ; yPos=yy ; }
   else if(c=='D'){ getXXYY() ; line(xPos,yPos,xx,yy) ; xPos=xx ; yPos=yy ;}
   else if(c=='L'){ execLine() ; }
   else if(c=='K'){ execBLine() ; }
   else if(c=='C'){ execCircle() ; }
   else if(c=='S') { getRRGGBB() ; stroke(rr,gg,bb) ; }
   else if(c=='B'){ background(0) ; }
   else if(c=='T'){ execText() ; }
   else { print(c) ; }
  }

void draw(){
  for(int k=0 ; k<50 ; k++){
    execChar() ;
    }
  }



//----------------------------------------------------------------------------------------  
