
//---------------------------------------------------------------------------------------   
import processing.serial.*;

Serial myPort;       

final int CR=13 ;
final int LF=10 ;

boolean isNum(char c){
  if (c<'0') return false ;
  if (c>'9') return false ;
  return true ;
  }

volatile int m ;

char getChar(){
  char c ;
   while (myPort.available()<=0) { 
     m++ ;
     } ;
   c=(char) myPort.read() ;
//   print(c) ;
   return c ;
  }



    
//---------------------------------------------------------------------------------------     
   

int xSize=1000 ;
int ySize=800 ;


void settings(){
  size(xSize, ySize, P3D);
  }
   
String portName="COM2" ;
   
void setup(){
  println("Setup()....") ;
  myPort = new Serial(this, portName, 115200);
  background(0) ;
  strokeWeight(2) ;
  stroke(255,255,255) ;
  textSize(16) ;
 
  /*simDsp() ;
  Complex C1=new Complex(1,1) ;
  print("C1="+C1.toString1()) ;
  sweep() ;
  */
  
  }

//----------------------------------------------------------------------------------------
Complex COMPLEX=new Complex(0.0,0.0) ;

Complex gainRLC(float f){
  Complex zL=COMPLEX.Limpedance(10e-3,f) ;
  Complex zRL=COMPLEX.Rimpedance(25,f) ;
  zL=zL.plus(zRL) ;
   
  Complex zC=COMPLEX.Cimpedance(100e-9,f) ;
  Complex zCL=COMPLEX.Rimpedance(50,f) ;
  zC=zC.plus(zCL) ;
  
  Complex CparL=zC.par(zL) ;
  Complex zR=COMPLEX.Rimpedance(1e3,f) ;
  Complex zQ=CparL.plus(zR) ;
  Complex zP=CparL ;
  Complex g=zP.divides(zQ) ;
  return g ;
  }
  
float lastFrq=1e6 ;
float lastG=0 ;
float lastP=0 ;

void sweep(){
   SStroke(255,255,255) ;
  float frq=100 ;
  while(frq<50e3){
    Complex gg=gainRLC(frq) ;
    float g=(float) gg.abs() ;
    float p=(float) ( gg.phase()*180.0/PI) ;
    if(frq>lastFrq){
      line(xOfF(lastFrq),yOfG(lastG),xOfF(frq),yOfG(g)) ;
      line(xOfF(lastFrq),yOfP(lastP),xOfF(frq),yOfP(p)) ;
      }
    lastFrq=frq ;
    lastG=g ;
    lastP=p ;
    frq=frq*1.05 ;
    }
  }

//----------------------------------------------------------------------------------------


void MMove(int xx,int yy){
  xPos=xx ; yPos=yy ;
  }
  
void DDraw(int xx, int yy){  
 line(xPos,yPos,xx,yy) ; xPos=xx ; yPos=yy ;
  }

void LLine(int xx1, int yy1, int xx, int yy){  
 line(xx1,yy1,xx,yy) ;
 xPos=xx ; yPos=yy ; 
  }
  
void SStroke(int rr, int gg, int bb){
  stroke(rr,gg,bb) ;
  }
  
void TText(String tt){
  fill(255,255,0) ;
  text(tt,xPos,yPos) ;  
  }

void brokenLine(int xx0, int yy0, int xx1 , int yy1, int m){
  int x,y,dx,dy,d,xss,yss ;
  int toggle,toggleCnt ;
  x=xx0 ; y=yy0 ;
  toggleCnt=0 ;
  toggle=1 ;
  point(x,y) ;
  dy=yy1-yy0 ; if (dy<0) {dy=-dy ; }
  dx=xx1-xx0 ; if (dx<0) {dx=-dx ; } 
  d=dx-dy ;
  if (xx1>xx0) { xss=1 ; } else { xss=-1 ; } ;
  if (yy1>yy0) { yss=1 ; } else { yss=-1 ; } ;
  while ( (x!=xx1) || (y!=yy1) ) {
    if (d>=0){ x += xss ; d -=dy ; }
    if (d<0) { y+=yss ; d+=dx ; }
    if(toggle==1){  point(x,y) ; }
    toggleCnt++ ;
    if(toggleCnt>=m){ toggleCnt=0 ; toggle=1-toggle ; }
    }     
    
  }

//----------------------------------------------------------------------------------------

int dd=5 ;
int phSize=200 ;
int ee=ySize-phSize ;

float fMin=100 ;
float fMax=50e3 ;

float gMax=1.4 ;
float gMin=0.0007 ;

float pMax=180+20 ;
float pMin=-180-20 ;

float log10(float x){
  return (float)Math.log10(x) ;
  }

float logx(float f){
  return log10(f) ;
  }

int xOfF(float f){
  if(f<fMin){ f=fMin ; }
  if(f>fMax) { f=fMax ; }
  
  return (int)( dd+(xSize-2*dd)*(logx(f)-logx(fMin))/(logx(fMax)-logx(fMin)) ) ;
  }
  
float dBg(float g){
  return 20.0*log10(g) ;
}

int yOfG(float g){
  if(g<gMin){ g=gMin ; }
  if(g>gMax){ g=gMax ; }
  return (int)( ee-(ee-dd)*(dBg(g)-dBg(gMin))/(dBg(gMax)-dBg(gMin)) );
  }
  
int yOfP(float p){
  if(p<pMin){ p=pMin ; }
  if(p>pMax){ p=pMax ; }
  return (int)( ySize-dd-(phSize)*(p-pMin)/(pMax-pMin) );
  }
  
  

void yLine(float f){
  int xx=xOfF(f) ;
  //LLine(xx,dd,xx,ySize-dd) ;
  brokenLine(xx,dd,xx,ySize-dd,15) ;
  }
  
void xLineG(float g){
  int yy=yOfG(g) ;
  //LLine(xx,dd,xx,ySize-dd) ;
  brokenLine(dd,yy,xSize-dd,yy,15) ;
  }  

void xLineP(float p){
  int yy=yOfP(p) ;
  //LLine(xx,dd,xx,ySize-dd) ;
  brokenLine(dd,yy,xSize-dd,yy,15) ;
  }  
  
void simDsp(){
  SStroke(255,0,0) ; 
  MMove(dd,dd) ;
  DDraw(xSize-dd,dd) ;
  DDraw(xSize-dd,ySize-dd) ;
  DDraw(dd,ySize-dd) ;
  DDraw(dd,dd) ;
  
  LLine(dd,ee,xSize-dd,ee) ;
  SStroke(0,0,255) ;
 // LLine(xOfF(fMin),300,xOfF(fMax),300) ;
 // LLine(200,yOfG(gMin),200,yOfG(gMax)) ;
 yLine(200) ; MMove(xOfF(200)+2,ee-3) ; TText("200") ;
 yLine(500) ; MMove(xOfF(500)+2,ee-3) ; TText("500") ;
  yLine(1000) ; MMove(xOfF(1000)+2,ee-3) ; TText("1k") ;
  yLine(2000) ; MMove(xOfF(2000)+2,ee-3) ; TText("2k") ;
  yLine(5000) ; MMove(xOfF(5000)+2,ee-3) ; TText("5k") ;
  yLine(10000) ;  MMove(xOfF(10000)+2,ee-3) ; TText("10k") ;
  yLine(20000) ;  MMove(xOfF(20000)+2,ee-3) ; TText("20k") ;

  xLineG(1.0) ;  MMove(dd+2,yOfG(1.0)-3) ; TText("0 dB") ;
  xLineG(0.1) ; MMove(dd+2,yOfG(0.1)-3) ; TText("-10 dB") ;
  xLineG(0.01) ;MMove(dd+2,yOfG(0.01)-3) ; TText("-20 dB") ;
  xLineG(0.001) ;MMove(dd+2,yOfG(0.001)-3) ; TText("-30 dB") ;
  
  xLineP(0.0) ;  MMove(dd+2,yOfP(1.0)-3) ; TText("0") ;
  xLineP(180.0) ;  MMove(dd+2,yOfP(180.0)+23) ; TText("180") ;
  xLineP(-180.0) ;  MMove(dd+2,yOfP(-180.0)-3) ; TText("-180") ;
  
  }

//----------------------------------------------------------------------------------------

String getPar(){
  char c ;
  String s="" ;
  do{ c=getChar() ; s=s+c ; } while(c!=';') ;
  //print("["+s+"]") ;
  return s ;
  }

String getVar(char cc){
  char c ;
  do{ c=getChar() ; } while(c!=cc) ;
  c=getChar() ;
  if(c!=':'){ println("format error1") ; }
  return getPar() ;
  }

int scanInt(String s){
  int val=0 ;
  int sign=1 ;
  for(int k=0 ; k<s.length() ; k++){
    char c=s.charAt(k) ;
    if(c=='-'){ sign=-1 ; }
    if(('0'<=c)&(c<='9')){
      val=10*val+c-'0' ;
      }
    }
  return sign*val ;  
  }
  
float scanFloat(String s){
  float val=0 ;
  int sign=1 ;
  int behindDp=0 ;
  float scale=1.0 ;
  for(int k=0 ; k<s.length() ; k++){
    char c=s.charAt(k) ;
    if(c=='-'){ sign=-1 ; }
    if(c=='.'){ behindDp=1 ; scale=0.1 ; }
    if(('0'<=c)&(c<='9')){
      if(behindDp==0){ val=10*val+c-'0' ;} else { val=val+scale*(c-'0') ;  scale=scale*0.1 ; behindDp++ ; }
      }
    }
  return sign*val ;  
  }

int xx,yy ;
int rr,gg,bb ;
int xPos,yPos ;

void getXXYY(){
  String sx=getPar() ;
  xx=scanInt(sx) ;
  String sy=getPar() ;
  yy=scanInt(sy) ;
}

void getRRGGBB(){
  String sr=getPar() ;
  rr=scanInt(sr) ;
  String sg=getPar() ;
  gg=scanInt(sg) ;
  String sb=getPar() ;
  bb=scanInt(sb) ;
}

void skipTo(char cc){
  char c ;
  do{ c=getChar() ;
    } while(c!=cc) ;
  }

void execText(){
  char c;
  println("execText") ;
  skipTo('"') ;
  String s="" ;
  do{ c=getChar() ; if(c!='"') { s=s+c ; } 
    } while (c!='"') ;
  print("text=[[") ; print(s) ; println("]]") ;
  fill(255,255,0) ;
  text(s,xPos,yPos) ;  
  println("end execText") ;
  }

void execLine(){
  getXXYY() ; 
  xPos=xx ; 
  yPos=yy ; 
  getXXYY() ; 
  line(xPos,yPos,xx,yy) ;
 // println("LINE(",xPos,",",yPos,",",xx,",",yy,")") ;
  xPos=xx ; yPos=yy ;
  }
  
void execBLine(){
  getXXYY() ; 
  xPos=xx ; 
  yPos=yy ; 
  getXXYY() ; 
  String mm=getPar() ;
  int m=scanInt(mm) ;
  brokenLine(xPos,yPos,xx,yy,m) ;
 // println("LINE(",xPos,",",yPos,",",xx,",",yy,")") ;
  xPos=xx ; yPos=yy ;
  }  

void execCircle(){
  String cc=getPar() ;
  rr=scanInt(cc) ;
  circle(xPos,yPos,rr) ;
  }

void execChar(){
  char c=getChar() ;
  if(c=='M'){ getXXYY() ; xPos=xx ; yPos=yy ; }
   else if(c=='D'){ getXXYY() ; line(xPos,yPos,xx,yy) ; xPos=xx ; yPos=yy ;}
   else if(c=='L'){ execLine() ; }
   else if(c=='K'){ execBLine() ; }
   else if(c=='C'){ execCircle() ; }
   else if(c=='S') { getRRGGBB() ; stroke(rr,gg,bb) ; }
   else if(c=='B'){ background(0) ; }
   else if(c=='T'){ execText() ; }
   else { print(c) ; }
  }

void draw(){
  for(int k=0 ; k<50 ; k++){
    execChar() ;
    }
  }



//----------------------------------------------------------------------------------------  
