//
//
//

#define HIGH 1
#define LOW 0

// F_CS not connected
// TFTreset not connected
// 3V3 not connected

#define TFTD0 16 // pin 21
#define TFTD1 17 // pin 22
#define TFTD2 18 // pin 24
#define TFTD3 19 // pin 25
#define TFTD4 20 // pin 26
#define TFTD5 21 // pin 27
#define TFTD6 22 // pin 29
#define TFTD7 26 // pin 31
//#define TFTreset 15 // pin 20 

#define TFTRD 15 // pin 20
#define TFTWR 14 // pin 19
#define TFTRS 13 // pin 17
#define TFTCS 12 // pin 16
#define TFTRST 11 // pin 15

#define LCD_REST TFTRST
#define LCD_CS TFTCS
#define LCD_WR TFTWR

#define CS_ACTIVE gpio_put2(TFTCS,LOW);
#define CS_IDLE gpio_put2(TFTCS,HIGH);
#define CC 0x2C // memory write command

#define CD_COMMAND gpio_put2(TFTRS, 0);
#define CD_DATA gpio_put2(TFTRS, 1);

#define WR_STROBE { WR_ACTIVE; WR_IDLE; }
#define RD_STROBE {RD_IDLE; RD_ACTIVE;RD_ACTIVE;RD_ACTIVE;}  
#define write16(d) { uint8_t h = (d)>>8, l = d; write8(h); write8(l); }
#define read16(dst) { uint8_t hi; read8(hi); read8(dst); dst |= (hi << 8); }
#define writeCmd8(x){ CD_COMMAND; write8(x); CD_DATA;  }
#define writeData8(x){  write8(x); }
#define writeCmd16(x){ CD_COMMAND; write16(x); CD_DATA; }
#define writeData16(x){ write16(x) }

// Set value of TFT register: 8-bit address, 8-bit value
#define writeCmdData8(a, d) { CD_COMMAND; write8(a); CD_DATA; write8(d); }

/*
#define ILI9341_SOFTRESET          0x01
#define ILI9341_SLEEPIN            0x10
#define ILI9341_SLEEPOUT           0x11
#define ILI9341_NORMALDISP         0x13
#define ILI9341_INVERTOFF          0x20
#define ILI9341_INVERTON           0x21
#define ILI9341_GAMMASET           0x26
#define ILI9341_DISPLAYOFF         0x28
#define ILI9341_DISPLAYON          0x29
#define ILI9341_COLADDRSET         0x2A
#define ILI9341_PAGEADDRSET        0x2B
#define ILI9341_MEMORYWRITE        0x2C
#define ILI9341_MEMORYACCESS       0x36
#define ILI9341_PIXELFORMAT        0x3A
#define ILI9341_RGBSIGNAL          0xB0
#define ILI9341_FRAMECONTROL       0xB1
#define ILI9341_INVERSIONCONRTOL   0xB4
#define ILI9341_DISPLAYFUNC        0xB6
#define ILI9341_ENTRYMODE          0xB7
#define ILI9341_POWERCONTROL1      0xC0
#define ILI9341_POWERCONTROL2      0xC1
#define ILI9341_VCOMCONTROL1       0xC5
#define ILI9341_VCOMCONTROL2       0xC7
#define ILI9341_POWERCONTROLB      0xCF
#define ILI9341_POWERCONTROLA      0xCB
#define ILI9341_UNDEFINE0          0xE0
#define ILI9341_UNDEFINE1          0xE1
#define ILI9341_DRIVERTIMINGA      0xE8
#define ILI9341_DRIVERTIMINGB      0xEA
#define ILI9341_POWERONSEQ         0xED
#define ILI9341_ENABLE3G           0xF2
#define ILI9341_INTERFACECONTROL   0xF6
#define ILI9341_RUMPRATIO          0xF7
#define ILI9341_MEMCONTROL         0x36
*/

#define ILI9341_MADCTL             0x36

#define ILI9341_MADCTL_MY  0x80
#define ILI9341_MADCTL_MX  0x40
#define ILI9341_MADCTL_MV  0x20
#define ILI9341_MADCTL_ML  0x10
#define ILI9341_MADCTL_RGB 0x00
#define ILI9341_MADCTL_BGR 0x08
#define ILI9341_MADCTL_MH  0x04

#define MD ILI9341_MADCTL
#define VL 1

void gpio_put2(int port,int x){
  //sleep_us(5) ;
  gpio_put(port,x) ;
  //sleep_us(10) ;
}

inline void setTFTDB(int D){
  gpio_put2(TFTD0, (D>>0) & 1);
  gpio_put2(TFTD1, (D>>1) & 1);
  gpio_put2(TFTD2, (D>>2) & 1);
  gpio_put2(TFTD3, (D>>3) & 1);
  gpio_put2(TFTD4, (D>>4) & 1);
  gpio_put2(TFTD5, (D>>5) & 1);
  gpio_put2(TFTD6, (D>>6) & 1);
  gpio_put2(TFTD7, (D>>7) & 1);
  }

void TFTwrData(int D, int CS, int RS){
  gpio_put2(TFTRS, RS);
  setTFTDB(D) ;
  gpio_put2(TFTWR, 0);
//  sleep_us(1) ;
  //asm volatile("nop");  asm volatile("nop");  asm volatile("nop");
  gpio_put2(TFTWR, 1);
//   sleep_us(1) ;
  }  

void TFTresetDo(){
  gpio_put2(TFTRST, 0);
  gpio_put2(TFTRST, 1);
  gpio_put2(TFTRD, 1);
  gpio_put2(TFTWR, 0);
  sleep_us(500) ;
  gpio_put2(TFTRST, 0);
  }

void Lcd_Write_Com(unsigned char VH) {   
  TFTwrData(VH,0,0) ;
  }

void Lcd_Write_Data(unsigned char VH){
   TFTwrData(VH,0,1) ;
  }

void Lcd_Write_Com_Data(unsigned char com,unsigned char dat){
  Lcd_Write_Com(com);
  Lcd_Write_Data(dat);
  }

void Address_set(unsigned int x1,unsigned int y1,unsigned int x2,unsigned int y2){
    Lcd_Write_Com(0x2a);
	Lcd_Write_Data(x1>>8);
	Lcd_Write_Data(x1);
	Lcd_Write_Data(x2>>8);
	Lcd_Write_Data(x2);
    Lcd_Write_Com(0x2b);
	Lcd_Write_Data(y1>>8);
	Lcd_Write_Data(y1);
	Lcd_Write_Data(y2>>8);
	Lcd_Write_Data(y2);
	Lcd_Write_Com(0x2c); 							 
}

void LCD_Clear(int j)                   {	
 int i,m;
 gpio_put2(LCD_CS,LOW);
 Address_set(0,0,320,480);
 //printf("LCDclr()...") ;
 for(i=0;i<320;i++)
   for(m=0;m<480;m++) {
     Lcd_Write_Data(j>>8);
     Lcd_Write_Data(j);
     }
  gpio_put2(LCD_CS,HIGH);   
 //printf("ready\n") ;
  }

void H_line(unsigned int x, unsigned int y, unsigned int l, unsigned int c){	
  unsigned int i,j;
  // printf("H_line(%d,%d,%d,%d)...",x,y,l,c) ;
  // Lcd_Write_Com(0x02c); //write_memory_start
  gpio_put2(TFTRS,HIGH);
  gpio_put2(TFTCS,LOW);
  l=l+x;
  //int x1=x+l ;
  Address_set(x,y,l,y);
  //Address_set(x,y,x1,y);
  //printf("Adress command was %4d %4d %4d %4d\n",x,y,l,y) ;
  j=l*2;
  for(i=1;i<=j;i++){
    Lcd_Write_Data(c >> 8);
    Lcd_Write_Data(c);
    //printf("x1 write data c=%04XH\n",c) ;
    }
  gpio_put2(TFTCS,HIGH);
  // printf("ready\n") ;   
  }

void ossiPixel1(unsigned int x, unsigned int y, unsigned int c) {	
  unsigned int i,j;
  // printf("ossi_pixel(%d,%d,%d)...",x,y,c) ;
  Lcd_Write_Com(0x02c); //write_memory_start
  gpio_put2(TFTRS,HIGH);
  gpio_put2(TFTCS,LOW);
  Address_set(x,y,x+1,y);
  //printf("Adress command was %4d %4d %4d %4d\n",x,y,x+1,y) ;
  Lcd_Write_Data(c >> 8);
  Lcd_Write_Data(c);
  // Lcd_Write_Data(c);
  //printf("x2 write data c=%04XH\n",c) ;
  gpio_put2(TFTCS,HIGH);
  //printf("ossi_pixel ready\n") ;   
  }

void V_line(unsigned int x, unsigned int y, unsigned int l, unsigned int c){	
  unsigned int i,j;
  Lcd_Write_Com(0x02c); //write_memory_start
  gpio_put2(TFTRS,HIGH);
  gpio_put2(TFTCS,LOW);
  l=l+y;
  Address_set(x,y,x,l);
  j=l*2;
  for(i=1;i<=j;i++) { 
    Lcd_Write_Data(c);
    }
  gpio_put2(TFTCS,HIGH);   
  }

void Rect(unsigned int x,unsigned int y,unsigned int w,unsigned int h,unsigned int c){
  H_line(x  , y  , w, c);
  H_line(x  , y+h, w, c);
  V_line(x  , y  , h, c);
  V_line(x+w, y  , h, c);
  }

void RectfOld(unsigned int x,unsigned int y,unsigned int w,unsigned int h,unsigned int c){
  unsigned int i;
  //printf("Rectf %d %d %d %d %c\n",x,y,w,h,c) ;
  for(i=0;i<h;i++){
    H_line(x  , y  , w, c);
    H_line(x  , y+i, w, c);
    }
  }

int Get_Width(){ return 320 ; }
int Get_Height(){ return 480 ; }

//fill area from x to x+w,y to y+h
void Rectf(int16_t x, int16_t y, int16_t w, int16_t h, uint16_t color){
	int16_t end;
	if (w < 0) {
    w = -w;
    x -= w;
    }                           //+ve w
  end = x + w;
  if (x < 0){
    x = 0;
    }
  if (end > Get_Width()){
    end = Get_Width();
    }
  w = end - x;
  if (h < 0) {
    h = -h;
    y -= h;
    }                           //+ve h
  end = y + h;
  if (y < 0){
    y = 0;
    }
  if (end > Get_Height()){
    end = Get_Height();
    }
  h = end - y;
  //Set_Addr_Window(x, y, x + w - 1, y + h - 1);//set area
  CS_ACTIVE;
  Address_set(x,y,x+w-1,y+h-1);

	//CS_ACTIVE;
 	//writeCmd8(CC);	
  Lcd_Write_Com(CC);
	if (h > w){
    end = h;
    h = w;
    w = end;
    }
	while (h-- > 0){
		end = w;
		do{
   		//writeData16(color);//set color data
      Lcd_Write_Data(color>>8);
      Lcd_Write_Data(color);
      } while (--end != 0);
	  }
  CS_IDLE;
  }

uint16_t rgb(uint8_t red, uint8_t green, uint8_t blue){
  uint16_t b = (blue >> 3) & 0x1f;
  uint16_t g = ((green >> 2) & 0x3f) << 5;
  uint16_t r = ((red >> 3) & 0x1f) << 11;
  return (uint16_t) (r | g | b);
  }

//int RGB(int r,int g,int b){
//  return r << 16 | g << 8 | b;
//  }

//------------------------------------------------------------------------------------------------------

#define TFTLCD_DELAY16  0xFFFF
#define TFTLCD_DELAY8   0x7F
#define MAX_REG_NUM     24

static const uint8_t ILI9486_regValues[] = {
				0xF1, 6, 0x36, 0x04, 0x00, 0x3C, 0x0F, 0x8F,
				0xF2, 9, 0x18, 0xA3, 0x12, 0x02, 0xB2, 0x12, 0xFF, 0x10, 0x00, 
				0xF8, 2, 0x21, 0x04,
				0xF9, 2, 0x00, 0x08,
		        0x36, 1, 0x08, 
        		0xB4, 1, 0x00,
				0xC1, 1, 0x41,
				0xC5, 4, 0x00, 0x91, 0x80, 0x00,
				0xE0, 15, 0x0F, 0x1F, 0x1C, 0x0C, 0x0F, 0x08, 0x48, 0x98, 0x37, 0x0A, 0x13, 0x04, 0x11, 0x0D, 0x00,
				0xE1, 15, 0x0F, 0x32, 0x2E, 0x0B, 0x0D, 0x05, 0x47, 0x75, 0x37, 0x06, 0x10 ,0x03, 0x24, 0x20, 0x00,				
				0x3A, 1, 0x55,
				0x11,0,
				0x36, 1, 0x28,
           		TFTLCD_DELAY8, 120,
				0x29,0
/*
				0x01, 0,            //Soft Reset
            	TFTLCD_DELAY8, 150,  // .kbv will power up with ONLY reset, sleep out, display on
            	0x28, 0,            //Display Off
            	0x3A, 1, 0x55,      //Pixel read=565, write=565.
            	0xC0, 2, 0x0d, 0x0d,        //Power Control 1 [0E 0E]
            	0xC1, 2, 0x43, 0x00,        //Power Control 2 [43 00]
            	0xC2, 1, 0x00,      //Power Control 3 [33]
            	0xC5, 4, 0x00, 0x48, 0x00, 0x48,    //VCOM  Control 1 [00 40 00 40]
            	0xB4, 1, 0x00,      //Inversion Control [00]
            	0xB6, 3, 0x02, 0x02, 0x3B,  // Display Function Control [02 02 3B] 
            	0xE0, 15,0x0F, 0x24, 0x1C, 0x0A, 0x0F, 0x08, 0x43, 0x88, 0x32, 0x0F, 0x10, 0x06, 0x0F, 0x07, 0x00,
            	0xE1, 15,0x0F, 0x38, 0x30, 0x09, 0x0F, 0x0F, 0x4E, 0x77, 0x3C, 0x07, 0x10, 0x05, 0x23, 0x1B, 0x00,
            	0x11, 0,            //Sleep Out
            	TFTLCD_DELAY8, 150,
            	0x29, 0         //Display On
*/
			};

void write8(int D){
  setTFTDB(D) ;
  gpio_put2(TFTWR, 0);
//  sleep_us(1) ;
  asm volatile("nop");  asm volatile("nop");  asm volatile("nop");
  gpio_put2(TFTWR, 1);
//  sleep_us(1) ;
  }  

void Invert_Display(bool i){
  CS_ACTIVE;
  uint8_t val = VL^i;
  writeCmd8(val ? 0x21 : 0x20);
  CS_IDLE;
  }

void setRotation(int rotation){
  uint8_t val;
  printf("setRotation rotation = %02d\n",rotation) ;  
  switch (rotation) {
	case 0:
	   	val = ILI9341_MADCTL_MX | ILI9341_MADCTL_BGR; //0 degree 
	   	break;
	case 1:
	   	val = ILI9341_MADCTL_MV | ILI9341_MADCTL_ML | ILI9341_MADCTL_BGR ; //90 degree 
	   	break;
	case 2:
	   	val = ILI9341_MADCTL_MY |ILI9341_MADCTL_BGR; //180 degree 
	   	break;
	case 3:
	   	val = ILI9341_MADCTL_MX | ILI9341_MADCTL_MY | ILI9341_MADCTL_MV | ILI9341_MADCTL_BGR; //270 degree
	   	break;
	}
  //val=0x48 ;
  printf("forced to 048H") ;  
  printf("setRotation write %02xH %02xH\n",MD,val) ;
  CS_ACTIVE;
  Lcd_Write_Com(MD) ;
  Lcd_Write_Data(val) ;  
  CS_IDLE;
  // writeCmdData8(MD, val); 
  }

void Push_Command(uint16_t cmd, uint8_t *block, int8_t N){
  CS_ACTIVE;
  Lcd_Write_Com(cmd) ;
  while (N-- > 0) {
    uint8_t u8 = *block++;
    Lcd_Write_Data(u8) ;
    }
  CS_IDLE;
  }

void init_table8(const void *table, int16_t size){
  uint8_t i;
  uint8_t *p = (uint8_t *) table, dat[MAX_REG_NUM];            //R61526 has GAMMA[22] 
  while (size > 0) {
    uint8_t cmd = *(p++);
    uint8_t len = *(p++);
    if (cmd == TFTLCD_DELAY8){
      sleep_ms(len);
      len = 0;
      } 
	 else {
      for (i = 0; i < len; i++){
        dat[i] = *(p++);
        }
      Push_Command(cmd,dat,len);
      }
    size -= len + 2;
    }
  }

void LCDinit2(){
  printf("Lcd_Init()...") ;
  TFTresetDo() ;

  gpio_put2(LCD_REST,HIGH);
  sleep_us(5); 
  gpio_put2(LCD_REST,LOW);
  sleep_ms(500);
  gpio_put2(LCD_REST,HIGH);
  
  sleep_ms(500);

  CS_ACTIVE;
  CD_COMMAND;
  write8(0x00);
  for(uint8_t i=0; i<3; i++) {
  	//WR_STROBE; // Three extra 0x00s
    gpio_put2(TFTWR, 0);
    sleep_us(1) ;
    gpio_put2(TFTWR, 1);
    sleep_us(1) ;
    }
  CS_IDLE;
  init_table8(ILI9486_regValues,sizeof(ILI9486_regValues)) ;
  setRotation(2) ;
  Invert_Display(0) ;
  }

//------------------------------------------------------------------------------------------------------

#define LCDOn 1

void bresenham1(int xx0, int yy0, int xx1 , int yy1, int color){
  int x,y,dx,dy,d,xss,yss ;
  if(LCDOn!=1) return ;
  x=xx0 ; y=yy0 ;
  ossiPixel1(x,y,color) ;
  dy=yy1-yy0 ; if (dy<0) {dy=-dy ; }
  dx=xx1-xx0 ; if (dx<0) {dx=-dx ; } 
  d=dx-dy ;
  if (xx1>xx0) { xss=1 ; } else { xss=-1 ; } ;
  if (yy1>yy0) { yss=1 ; } else { yss=-1 ; } ;
  while ( (x!=xx1) || (y!=yy1) ) {
    if (d>=0){ x += xss ; d -=dy ; }
    if (d<0) { y+=yss ; d+=dx ; }
    ossiPixel1(x,y,color) ;
    }
  // lastX=x ;
  // lastY=y ;
  }  

//------------------------------------------------------------------------------------------------------

int cursorX=0 ;
int cursorY=0 ;
int xs=1 ; // chr dotsize
int ys=1 ;

int chr6x8rom[256][8] ;

void chrGenSet2(int number, int r0,int r1,int r2,int r3,int r4,int r5,int r6,int r7) {
  chr6x8rom[number][0]=r0 ;
  chr6x8rom[number][1]=r1 ;
  chr6x8rom[number][2]=r2 ;
  chr6x8rom[number][3]=r3 ;
  chr6x8rom[number][4]=r4 ;
  chr6x8rom[number][5]=r5 ;
  chr6x8rom[number][6]=r6 ;
  chr6x8rom[number][7]=r7 ;
  }

void getFont6x8(){
//6x8_horizontal_LSB_1.h
chrGenSet2(  0,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00) ;  // 0x00
chrGenSet2(  1,0x70,0x88,0xD8,0x88,0xA8,0x88,0x70,0x00) ;  // 0x01
chrGenSet2(  2,0x70,0xF8,0xA8,0xF8,0x88,0xF8,0x70,0x00) ;  // 0x02
chrGenSet2(  3,0x00,0x50,0xF8,0xF8,0xF8,0x70,0x20,0x00) ;  // 0x03
chrGenSet2(  4,0x00,0x20,0x70,0xF8,0xF8,0x70,0x20,0x00) ;  // 0x04
chrGenSet2(  5,0x20,0x70,0x70,0x20,0xF8,0xF8,0x20,0x00) ;  // 0x05
chrGenSet2(  6,0x00,0x20,0x70,0xF8,0xF8,0x20,0x70,0x00) ;  // 0x06
chrGenSet2(  7,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00) ;  // 0x07
chrGenSet2(  8,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00) ;  // 0x08
chrGenSet2(  9,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00) ;  // 0x09
chrGenSet2( 10,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00) ;  // 0x0A
chrGenSet2( 11,0x00,0xE0,0xC0,0xB0,0x48,0x48,0x30,0x00) ;  // 0x0B
chrGenSet2( 12,0x70,0x88,0x88,0x70,0x20,0x70,0x20,0x00) ;  // 0x0C
chrGenSet2( 13,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00) ;  // 0x0D
chrGenSet2( 14,0xC0,0xB0,0xD0,0xB0,0xD0,0xD8,0x18,0x00) ;  // 0x0E
chrGenSet2( 15,0x00,0xA8,0x70,0xD8,0x70,0xA8,0x00,0x00) ;  // 0x0F
chrGenSet2( 16,0x10,0x30,0x70,0xF0,0x70,0x30,0x10,0x00) ;  // 0x10
chrGenSet2( 17,0x40,0x60,0x70,0x78,0x70,0x60,0x40,0x00) ;  // 0x11
chrGenSet2( 18,0x20,0x70,0xF8,0x20,0xF8,0x70,0x20,0x00) ;  // 0x12
chrGenSet2( 19,0x50,0x50,0x50,0x50,0x50,0x00,0x50,0x00) ;  // 0x13
chrGenSet2( 20,0xF0,0xA8,0xA8,0xB0,0xA0,0xA0,0xA0,0x00) ;  // 0x14
chrGenSet2( 21,0x70,0x88,0x30,0x50,0x60,0x88,0x70,0x00) ;  // 0x15
chrGenSet2( 22,0x00,0x00,0x00,0x00,0x00,0x78,0x78,0x00) ;  // 0x16
chrGenSet2( 23,0x20,0x70,0xF8,0x20,0xF8,0x70,0x20,0x70) ;  // 0x17
chrGenSet2( 24,0x20,0x70,0xF8,0x20,0x20,0x20,0x20,0x00) ;  // 0x18
chrGenSet2( 25,0x20,0x20,0x20,0x20,0xF8,0x70,0x20,0x00) ;  // 0x19
chrGenSet2( 26,0x00,0x20,0x60,0xF8,0x60,0x20,0x00,0x00) ;  // 0x1A
chrGenSet2( 27,0x00,0x20,0x30,0xF8,0x30,0x20,0x00,0x00) ;  // 0x1B
chrGenSet2( 28,0x00,0x00,0x00,0x08,0x08,0x08,0xF8,0x00) ;  // 0x1C
chrGenSet2( 29,0x00,0x50,0x50,0xF8,0x50,0x50,0x00,0x00) ;  // 0x1D
chrGenSet2( 30,0x20,0x20,0x70,0x70,0xF8,0xF8,0x00,0x00) ;  // 0x1E
chrGenSet2( 31,0xF8,0xF8,0x70,0x70,0x20,0x20,0x00,0x00) ;  // 0x1F
chrGenSet2( 32,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00) ;  // 0x20
chrGenSet2( 33,0x20,0x70,0x70,0x20,0x20,0x00,0x20,0x00) ;  // 0x21
chrGenSet2( 34,0xD8,0xD8,0x48,0x00,0x00,0x00,0x00,0x00) ;  // 0x22
chrGenSet2( 35,0x00,0x50,0xF8,0x50,0x50,0xF8,0x50,0x00) ;  // 0x23
chrGenSet2( 36,0x10,0x70,0x08,0x30,0x40,0x38,0x20,0x00) ;  // 0x24
chrGenSet2( 37,0x98,0x98,0x40,0x20,0x10,0xC8,0xC8,0x00) ;  // 0x25
chrGenSet2( 38,0x10,0x28,0x28,0x10,0xA8,0x48,0xB0,0x00) ;  // 0x26
chrGenSet2( 39,0x30,0x30,0x10,0x00,0x00,0x00,0x00,0x00) ;  // 0x27
chrGenSet2( 40,0x20,0x10,0x10,0x10,0x10,0x10,0x20,0x00) ;  // 0x28
chrGenSet2( 41,0x10,0x20,0x20,0x20,0x20,0x20,0x10,0x00) ;  // 0x29
chrGenSet2( 42,0x00,0x50,0x70,0xF8,0x70,0x50,0x00,0x00) ;  // 0x2A
chrGenSet2( 43,0x00,0x20,0x20,0xF8,0x20,0x20,0x00,0x00) ;  // 0x2B
chrGenSet2( 44,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x10) ;  // 0x2C
chrGenSet2( 45,0x00,0x00,0x00,0xF8,0x00,0x00,0x00,0x00) ;  // 0x2D
chrGenSet2( 46,0x00,0x00,0x00,0x00,0x00,0x30,0x30,0x00) ;  // 0x2E
chrGenSet2( 47,0x00,0x80,0x40,0x20,0x10,0x08,0x00,0x00) ;  // 0x2F
chrGenSet2( 48,0x70,0x88,0xC8,0xA8,0x98,0x88,0x70,0x00) ;  // 0x30
chrGenSet2( 49,0x20,0x30,0x20,0x20,0x20,0x20,0x70,0x00) ;  // 0x31
chrGenSet2( 50,0x70,0x88,0x80,0x60,0x10,0x08,0xF8,0x00) ;  // 0x32
chrGenSet2( 51,0x70,0x88,0x80,0x70,0x80,0x88,0x70,0x00) ;  // 0x33
chrGenSet2( 52,0x40,0x60,0x50,0x48,0xF8,0x40,0x40,0x00) ;  // 0x34
chrGenSet2( 53,0xF8,0x08,0x08,0x78,0x80,0x88,0x70,0x00) ;  // 0x35
chrGenSet2( 54,0x60,0x10,0x08,0x78,0x88,0x88,0x70,0x00) ;  // 0x36
chrGenSet2( 55,0xF8,0x80,0x40,0x20,0x10,0x10,0x10,0x00) ;  // 0x37
chrGenSet2( 56,0x70,0x88,0x88,0x70,0x88,0x88,0x70,0x00) ;  // 0x38
chrGenSet2( 57,0x70,0x88,0x88,0xF0,0x80,0x40,0x30,0x00) ;  // 0x39
chrGenSet2( 58,0x00,0x00,0x30,0x30,0x00,0x30,0x30,0x00) ;  // 0x3A
chrGenSet2( 59,0x00,0x00,0x30,0x30,0x00,0x30,0x30,0x10) ;  // 0x3B
chrGenSet2( 60,0x40,0x20,0x10,0x08,0x10,0x20,0x40,0x00) ;  // 0x3C
chrGenSet2( 61,0x00,0x00,0xF8,0x00,0x00,0xF8,0x00,0x00) ;  // 0x3D
chrGenSet2( 62,0x10,0x20,0x40,0x80,0x40,0x20,0x10,0x00) ;  // 0x3E
chrGenSet2( 63,0x70,0x88,0x80,0x60,0x20,0x00,0x20,0x00) ;  // 0x3F
chrGenSet2( 64,0x70,0x88,0xE8,0xA8,0xE8,0x08,0x70,0x00) ;  // 0x40
chrGenSet2( 65,0x70,0x88,0x88,0x88,0xF8,0x88,0x88,0x00) ;  // 0x41
chrGenSet2( 66,0x78,0x88,0x88,0x78,0x88,0x88,0x78,0x00) ;  // 0x42
chrGenSet2( 67,0x70,0x88,0x08,0x08,0x08,0x88,0x70,0x00) ;  // 0x43
chrGenSet2( 68,0x78,0x88,0x88,0x88,0x88,0x88,0x78,0x00) ;  // 0x44
chrGenSet2( 69,0xF8,0x08,0x08,0x78,0x08,0x08,0xF8,0x00) ;  // 0x45
chrGenSet2( 70,0xF8,0x08,0x08,0x78,0x08,0x08,0x08,0x00) ;  // 0x46
chrGenSet2( 71,0x70,0x88,0x08,0xE8,0x88,0x88,0xF0,0x00) ;  // 0x47
chrGenSet2( 72,0x88,0x88,0x88,0xF8,0x88,0x88,0x88,0x00) ;  // 0x48
chrGenSet2( 73,0x70,0x20,0x20,0x20,0x20,0x20,0x70,0x00) ;  // 0x49
chrGenSet2( 74,0x80,0x80,0x80,0x80,0x88,0x88,0x70,0x00) ;  // 0x4A
chrGenSet2( 75,0x88,0x48,0x28,0x18,0x28,0x48,0x88,0x00) ;  // 0x4B
chrGenSet2( 76,0x08,0x08,0x08,0x08,0x08,0x08,0xF8,0x00) ;  // 0x4C
chrGenSet2( 77,0x88,0xD8,0xA8,0x88,0x88,0x88,0x88,0x00) ;  // 0x4D
chrGenSet2( 78,0x88,0x98,0xA8,0xC8,0x88,0x88,0x88,0x00) ;  // 0x4E
chrGenSet2( 79,0x70,0x88,0x88,0x88,0x88,0x88,0x70,0x00) ;  // 0x4F
chrGenSet2( 80,0x78,0x88,0x88,0x78,0x08,0x08,0x08,0x00) ;  // 0x50
chrGenSet2( 81,0x70,0x88,0x88,0x88,0xA8,0x48,0xB0,0x00) ;  // 0x51
chrGenSet2( 82,0x78,0x88,0x88,0x78,0x48,0x88,0x88,0x00) ;  // 0x52
chrGenSet2( 83,0x70,0x88,0x08,0x70,0x80,0x88,0x70,0x00) ;  // 0x53
chrGenSet2( 84,0xF8,0x20,0x20,0x20,0x20,0x20,0x20,0x00) ;  // 0x54
chrGenSet2( 85,0x88,0x88,0x88,0x88,0x88,0x88,0x70,0x00) ;  // 0x55
chrGenSet2( 86,0x88,0x88,0x88,0x88,0x88,0x50,0x20,0x00) ;  // 0x56
chrGenSet2( 87,0x88,0x88,0xA8,0xA8,0xA8,0xA8,0x50,0x00) ;  // 0x57
chrGenSet2( 88,0x88,0x88,0x50,0x20,0x50,0x88,0x88,0x00) ;  // 0x58
chrGenSet2( 89,0x88,0x88,0x88,0x50,0x20,0x20,0x20,0x00) ;  // 0x59
chrGenSet2( 90,0x78,0x40,0x20,0x10,0x08,0x08,0x78,0x00) ;  // 0x5A
chrGenSet2( 91,0x70,0x10,0x10,0x10,0x10,0x10,0x70,0x00) ;  // 0x5B
chrGenSet2( 92,0x00,0x08,0x10,0x20,0x40,0x80,0x00,0x00) ;  // 0x5C
chrGenSet2( 93,0x70,0x40,0x40,0x40,0x40,0x40,0x70,0x00) ;  // 0x5D
chrGenSet2( 94,0x20,0x50,0x88,0x00,0x00,0x00,0x00,0x00) ;  // 0x5E
chrGenSet2( 95,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0xFC) ;  // 0x5F
chrGenSet2( 96,0x30,0x30,0x20,0x00,0x00,0x00,0x00,0x00) ;  // 0x60
chrGenSet2( 97,0x00,0x00,0x70,0x80,0xF0,0x88,0xF0,0x00) ;  // 0x61
chrGenSet2( 98,0x08,0x08,0x78,0x88,0x88,0x88,0x78,0x00) ;  // 0x62
chrGenSet2( 99,0x00,0x00,0x70,0x88,0x08,0x88,0x70,0x00) ;  // 0x63
chrGenSet2(100,0x80,0x80,0xF0,0x88,0x88,0x88,0xF0,0x00) ;  // 0x64
chrGenSet2(101,0x00,0x00,0x70,0x88,0x78,0x08,0x70,0x00) ;  // 0x65
chrGenSet2(102,0x60,0x10,0x10,0x78,0x10,0x10,0x10,0x00) ;  // 0x66
chrGenSet2(103,0x00,0x00,0xF0,0x88,0x88,0xF0,0x80,0x70) ;  // 0x67
chrGenSet2(104,0x08,0x08,0x38,0x48,0x48,0x48,0x48,0x00) ;  // 0x68
chrGenSet2(105,0x20,0x00,0x20,0x20,0x20,0x20,0x60,0x00) ;  // 0x69
chrGenSet2(106,0x40,0x00,0x60,0x40,0x40,0x40,0x48,0x30) ;  // 0x6A
chrGenSet2(107,0x08,0x08,0x48,0x28,0x18,0x28,0x48,0x00) ;  // 0x6B
chrGenSet2(108,0x20,0x20,0x20,0x20,0x20,0x20,0x60,0x00) ;  // 0x6C
chrGenSet2(109,0x00,0x00,0x58,0xA8,0xA8,0x88,0x88,0x00) ;  // 0x6D
chrGenSet2(110,0x00,0x00,0x38,0x48,0x48,0x48,0x48,0x00) ;  // 0x6E
chrGenSet2(111,0x00,0x00,0x70,0x88,0x88,0x88,0x70,0x00) ;  // 0x6F
chrGenSet2(112,0x00,0x00,0x78,0x88,0x88,0x88,0x78,0x08) ;  // 0x70
chrGenSet2(113,0x00,0x00,0xF0,0x88,0x88,0x88,0xF0,0x80) ;  // 0x71
chrGenSet2(114,0x00,0x00,0x68,0x90,0x10,0x10,0x38,0x00) ;  // 0x72
chrGenSet2(115,0x00,0x00,0x70,0x08,0x70,0x80,0x70,0x00) ;  // 0x73
chrGenSet2(116,0x00,0x10,0x78,0x10,0x10,0x50,0x20,0x00) ;  // 0x74
chrGenSet2(117,0x00,0x00,0x48,0x48,0x48,0x68,0x50,0x00) ;  // 0x75
chrGenSet2(118,0x00,0x00,0x88,0x88,0x88,0x50,0x20,0x00) ;  // 0x76
chrGenSet2(119,0x00,0x00,0x88,0x88,0xA8,0xF8,0x50,0x00) ;  // 0x77
chrGenSet2(120,0x00,0x00,0x48,0x48,0x30,0x48,0x48,0x00) ;  // 0x78
chrGenSet2(121,0x00,0x00,0x48,0x48,0x48,0x70,0x20,0x18) ;  // 0x79
chrGenSet2(122,0x00,0x00,0x78,0x40,0x30,0x08,0x78,0x00) ;  // 0x7A
chrGenSet2(123,0x60,0x10,0x10,0x18,0x10,0x10,0x60,0x00) ;  // 0x7B
chrGenSet2(124,0x20,0x20,0x20,0x00,0x20,0x20,0x20,0x00) ;  // 0x7C
chrGenSet2(125,0x30,0x40,0x40,0xC0,0x40,0x40,0x30,0x00) ;  // 0x7D
chrGenSet2(126,0x50,0x28,0x00,0x00,0x00,0x00,0x00,0x00) ;  // 0x7E
chrGenSet2(127,0x20,0x70,0xD8,0x88,0x88,0xF8,0x00,0x00) ;  // 0x7F
chrGenSet2(128,0x70,0x88,0x08,0x08,0x88,0x70,0x20,0x30) ;  // 0x80
chrGenSet2(129,0x48,0x00,0x48,0x48,0x48,0x68,0x50,0x00) ;  // 0x81
chrGenSet2(130,0xC0,0x00,0x70,0x88,0x78,0x08,0x70,0x00) ;  // 0x82
chrGenSet2(131,0x70,0x00,0x70,0x80,0xF0,0x88,0xF0,0x00) ;  // 0x83
chrGenSet2(132,0x50,0x00,0x70,0x80,0xF0,0x88,0xF0,0x00) ;  // 0x84
chrGenSet2(133,0x30,0x00,0x70,0x80,0xF0,0x88,0xF0,0x00) ;  // 0x85
chrGenSet2(134,0x70,0x50,0x70,0x80,0xF0,0x88,0xF0,0x00) ;  // 0x86
chrGenSet2(135,0x00,0x70,0x88,0x08,0x88,0x70,0x20,0x30) ;  // 0x87
chrGenSet2(136,0x70,0x00,0x70,0x88,0x78,0x08,0x70,0x00) ;  // 0x88
chrGenSet2(137,0x50,0x00,0x70,0x88,0x78,0x08,0x70,0x00) ;  // 0x89
chrGenSet2(138,0x30,0x00,0x70,0x88,0x78,0x08,0x70,0x00) ;  // 0x8A
chrGenSet2(139,0x50,0x00,0x20,0x20,0x20,0x20,0x60,0x00) ;  // 0x8B
chrGenSet2(140,0x70,0x00,0x20,0x20,0x20,0x20,0x60,0x00) ;  // 0x8C
chrGenSet2(141,0x10,0x00,0x20,0x20,0x20,0x20,0x60,0x00) ;  // 0x8D
chrGenSet2(142,0x50,0x00,0x20,0x50,0x88,0xF8,0x88,0x00) ;  // 0x8E
chrGenSet2(143,0x70,0x50,0x70,0xD8,0x88,0xF8,0x88,0x00) ;  // 0x8F
chrGenSet2(144,0xC0,0x00,0xF8,0x08,0x78,0x08,0xF8,0x00) ;  // 0x90
chrGenSet2(145,0x00,0x00,0x78,0xA0,0xF8,0x28,0xF0,0x00) ;  // 0x91
chrGenSet2(146,0xF0,0x28,0x28,0xF8,0x28,0x28,0xE8,0x00) ;  // 0x92
chrGenSet2(147,0x70,0x00,0x30,0x48,0x48,0x48,0x30,0x00) ;  // 0x93
chrGenSet2(148,0x50,0x00,0x30,0x48,0x48,0x48,0x30,0x00) ;  // 0x94
chrGenSet2(149,0x18,0x00,0x30,0x48,0x48,0x48,0x30,0x00) ;  // 0x95
chrGenSet2(150,0x70,0x00,0x48,0x48,0x48,0x68,0x50,0x00) ;  // 0x96
chrGenSet2(151,0x18,0x00,0x48,0x48,0x48,0x68,0x50,0x00) ;  // 0x97
chrGenSet2(152,0x50,0x00,0x48,0x48,0x48,0x70,0x20,0x18) ;  // 0x98
chrGenSet2(153,0x48,0x30,0x48,0x48,0x48,0x48,0x30,0x00) ;  // 0x99
chrGenSet2(154,0x50,0x00,0x48,0x48,0x48,0x48,0x30,0x00) ;  // 0x9A
chrGenSet2(155,0x00,0x00,0x80,0x70,0x68,0x58,0x38,0x04) ;  // 0x9B
chrGenSet2(156,0x60,0x90,0x10,0x78,0x10,0x90,0xE8,0x00) ;  // 0x9C
chrGenSet2(157,0xF0,0xC8,0xA8,0xA8,0xA8,0x98,0x78,0x00) ;  // 0x9D
chrGenSet2(158,0x00,0x88,0x50,0x20,0x50,0x88,0x00,0x00) ;  // 0x9E
chrGenSet2(159,0x40,0xA0,0x20,0x70,0x20,0x20,0x28,0x10) ;  // 0x9F
chrGenSet2(160,0x60,0x00,0x70,0x80,0xF0,0x88,0xF0,0x00) ;  // 0xA0
chrGenSet2(161,0x60,0x00,0x20,0x20,0x20,0x20,0x60,0x00) ;  // 0xA1
chrGenSet2(162,0x60,0x00,0x30,0x48,0x48,0x48,0x30,0x00) ;  // 0xA2
chrGenSet2(163,0x60,0x00,0x48,0x48,0x48,0x68,0x50,0x00) ;  // 0xA3
chrGenSet2(164,0x50,0x28,0x00,0x38,0x48,0x48,0x48,0x00) ;  // 0xA4
chrGenSet2(165,0x50,0x28,0x00,0x48,0x58,0x68,0x48,0x00) ;  // 0xA5
chrGenSet2(166,0x70,0x80,0xF0,0x88,0xF0,0x00,0xF0,0x00) ;  // 0xA6
chrGenSet2(167,0x30,0x48,0x48,0x48,0x30,0x00,0x78,0x00) ;  // 0xA7
chrGenSet2(168,0x20,0x00,0x20,0x30,0x08,0x88,0x70,0x00) ;  // 0xA8
chrGenSet2(169,0x78,0xA4,0xD4,0xB4,0xD4,0x84,0x78,0x00) ;  // 0xA9
chrGenSet2(170,0x00,0x00,0xFC,0x80,0x80,0x00,0x00,0x00) ;  // 0xAA
chrGenSet2(171,0x08,0x48,0x28,0x70,0x88,0x40,0xE0,0x00) ;  // 0xAB
chrGenSet2(172,0x08,0x48,0x28,0xD0,0xA8,0xE0,0x80,0x00) ;  // 0xAC
chrGenSet2(173,0x20,0x00,0x20,0x20,0x70,0x70,0x20,0x00) ;  // 0xAD
chrGenSet2(174,0x00,0x00,0x90,0x48,0x90,0x00,0x00,0x00) ;  // 0xAE
chrGenSet2(175,0x00,0x00,0x48,0x90,0x48,0x00,0x00,0x00) ;  // 0xAF
chrGenSet2(176,0xA8,0x00,0x54,0x00,0xA8,0x00,0x54,0x00) ;  // 0xB0
chrGenSet2(177,0xA8,0x54,0xA8,0x54,0xA8,0x54,0xA8,0x54) ;  // 0xB1
chrGenSet2(178,0x54,0xFC,0xA8,0xFC,0x54,0xFC,0xA8,0xFC) ;  // 0xB2
chrGenSet2(179,0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20) ;  // 0xB3
chrGenSet2(180,0x20,0x20,0x20,0x3C,0x20,0x20,0x20,0x20) ;  // 0xB4
chrGenSet2(181,0x60,0x00,0x20,0x50,0x88,0xF8,0x88,0x00) ;  // 0xB5
chrGenSet2(182,0x70,0x00,0x20,0x50,0x88,0xF8,0x88,0x00) ;  // 0xB6
chrGenSet2(183,0x30,0x00,0x20,0x50,0x88,0xF8,0x88,0x00) ;  // 0xB7
chrGenSet2(184,0x78,0x84,0xB4,0x94,0xB4,0x84,0x78,0x00) ;  // 0xB8
chrGenSet2(185,0x28,0x2C,0x20,0x2C,0x28,0x28,0x28,0x28) ;  // 0xB9
chrGenSet2(186,0x28,0x28,0x28,0x28,0x28,0x28,0x28,0x28) ;  // 0xBA
chrGenSet2(187,0x00,0x3C,0x20,0x2C,0x28,0x28,0x28,0x28) ;  // 0xBB
chrGenSet2(188,0x28,0x2C,0x20,0x3C,0x00,0x00,0x00,0x00) ;  // 0xBC
chrGenSet2(189,0x00,0x20,0x70,0x08,0x08,0x70,0x20,0x00) ;  // 0xBD
chrGenSet2(190,0x88,0x50,0x20,0xF8,0x20,0xF8,0x20,0x00) ;  // 0xBE
chrGenSet2(191,0x00,0x00,0x00,0x3C,0x20,0x20,0x20,0x20) ;  // 0xBF
chrGenSet2(192,0x20,0x20,0x20,0xE0,0x00,0x00,0x00,0x00) ;  // 0xC0
chrGenSet2(193,0x20,0x20,0x20,0xFC,0x00,0x00,0x00,0x00) ;  // 0xC1
chrGenSet2(194,0x00,0x00,0x00,0xFC,0x20,0x20,0x20,0x20) ;  // 0xC2
chrGenSet2(195,0x20,0x20,0x20,0xE0,0x20,0x20,0x20,0x20) ;  // 0xC3
chrGenSet2(196,0x00,0x00,0x00,0xFC,0x00,0x00,0x00,0x00) ;  // 0xC4
chrGenSet2(197,0x20,0x20,0x20,0xFC,0x20,0x20,0x20,0x20) ;  // 0xC5
chrGenSet2(198,0xA0,0x50,0x70,0x80,0xF0,0x88,0xF0,0x00) ;  // 0xC6
chrGenSet2(199,0xA0,0x50,0x20,0x50,0x88,0xF8,0x88,0x00) ;  // 0xC7
chrGenSet2(200,0x28,0xE8,0x08,0xF8,0x00,0x00,0x00,0x00) ;  // 0xC8
chrGenSet2(201,0x00,0xF8,0x08,0xE8,0x28,0x28,0x28,0x28) ;  // 0xC9
chrGenSet2(202,0x28,0xEC,0x00,0xFC,0x00,0x00,0x00,0x00) ;  // 0xCA
chrGenSet2(203,0x00,0xFC,0x00,0xEC,0x28,0x28,0x28,0x28) ;  // 0xCB
chrGenSet2(204,0x28,0xE8,0x08,0xE8,0x28,0x28,0x28,0x28) ;  // 0xCC
chrGenSet2(205,0x00,0xFC,0x00,0xFC,0x00,0x00,0x00,0x00) ;  // 0xCD
chrGenSet2(206,0x28,0xEC,0x00,0xEC,0x28,0x28,0x28,0x28) ;  // 0xCE
chrGenSet2(207,0x88,0x70,0x88,0x88,0x88,0x70,0x88,0x00) ;  // 0xCF
chrGenSet2(208,0x30,0x08,0x10,0x20,0x70,0x48,0x30,0x00) ;  // 0xD0
chrGenSet2(209,0x70,0x90,0x90,0xB8,0x90,0x90,0x70,0x00) ;  // 0xD1
chrGenSet2(210,0x70,0x00,0xF8,0x08,0x78,0x08,0xF8,0x00) ;  // 0xD2
chrGenSet2(211,0x50,0x00,0xF8,0x08,0x78,0x08,0xF8,0x00) ;  // 0xD3
chrGenSet2(212,0x30,0x00,0xF8,0x08,0x78,0x08,0xF8,0x00) ;  // 0xD4
chrGenSet2(213,0x20,0x20,0x20,0x00,0x00,0x00,0x00,0x00) ;  // 0xD5
chrGenSet2(214,0x60,0x00,0x70,0x20,0x20,0x20,0x70,0x00) ;  // 0xD6
chrGenSet2(215,0x70,0x00,0x70,0x20,0x20,0x20,0x70,0x00) ;  // 0xD7
chrGenSet2(216,0x50,0x00,0x70,0x20,0x20,0x20,0x70,0x00) ;  // 0xD8
chrGenSet2(217,0x20,0x20,0x20,0x3C,0x00,0x00,0x00,0x00) ;  // 0xD9
chrGenSet2(218,0x00,0x00,0x00,0xE0,0x20,0x20,0x20,0x20) ;  // 0xDA
chrGenSet2(219,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC,0xFC) ;  // 0xDB
chrGenSet2(220,0x00,0x00,0x00,0x00,0xFC,0xFC,0xFC,0xFC) ;  // 0xDC
chrGenSet2(221,0x20,0x20,0x20,0x00,0x20,0x20,0x20,0x00) ;  // 0xDD
chrGenSet2(222,0x30,0x00,0x70,0x20,0x20,0x20,0x70,0x00) ;  // 0xDE
chrGenSet2(223,0xFC,0xFC,0xFC,0xFC,0x00,0x00,0x00,0x00) ;  // 0xDF
chrGenSet2(224,0x60,0x30,0x48,0x48,0x48,0x48,0x30,0x00) ;  // 0xE0
chrGenSet2(225,0x00,0x38,0x48,0x38,0x48,0x48,0x38,0x08) ;  // 0xE1
chrGenSet2(226,0x70,0x30,0x48,0x48,0x48,0x48,0x30,0x00) ;  // 0xE2
chrGenSet2(227,0x18,0x30,0x48,0x48,0x48,0x48,0x30,0x00) ;  // 0xE3
chrGenSet2(228,0x50,0x28,0x00,0x30,0x48,0x48,0x30,0x00) ;  // 0xE4
chrGenSet2(229,0x50,0x28,0x30,0x48,0x48,0x48,0x30,0x00) ;  // 0xE5
chrGenSet2(230,0x00,0x00,0x48,0x48,0x48,0x38,0x08,0x08) ;  // 0xE6
chrGenSet2(231,0x00,0x18,0x08,0x38,0x48,0x38,0x08,0x18) ;  // 0xE7
chrGenSet2(232,0x18,0x08,0x38,0x48,0x48,0x38,0x08,0x18) ;  // 0xE8
chrGenSet2(233,0x60,0x00,0x48,0x48,0x48,0x48,0x30,0x00) ;  // 0xE9
chrGenSet2(234,0x70,0x00,0x48,0x48,0x48,0x48,0x30,0x00) ;  // 0xEA
chrGenSet2(235,0x18,0x00,0x48,0x48,0x48,0x48,0x30,0x00) ;  // 0xEB
chrGenSet2(236,0x60,0x00,0x48,0x48,0x48,0x70,0x20,0x18) ;  // 0xEC
chrGenSet2(237,0x60,0x00,0x88,0x50,0x20,0x20,0x20,0x00) ;  // 0xED
chrGenSet2(238,0x00,0x70,0x00,0x00,0x00,0x00,0x00,0x00) ;  // 0xEE
chrGenSet2(239,0x30,0x30,0x10,0x00,0x00,0x00,0x00,0x00) ;  // 0xEF
chrGenSet2(240,0x00,0x00,0x00,0x70,0x00,0x00,0x00,0x00) ;  // 0xF0
chrGenSet2(241,0x00,0x20,0x70,0x20,0x00,0x70,0x00,0x00) ;  // 0xF1
chrGenSet2(242,0x00,0x00,0xF8,0x00,0x00,0xF8,0x00,0x00) ;  // 0xF2
chrGenSet2(243,0x0C,0x58,0x2C,0xD0,0xA8,0xE0,0x80,0x00) ;  // 0xF3
chrGenSet2(244,0xF0,0xA8,0xA8,0xB0,0xA0,0xA0,0xA0,0x00) ;  // 0xF4
chrGenSet2(245,0x70,0x88,0x30,0x50,0x60,0x88,0x70,0x00) ;  // 0xF5
chrGenSet2(246,0x00,0x20,0x00,0xF8,0x00,0x20,0x00,0x00) ;  // 0xF6
chrGenSet2(247,0x00,0x00,0x00,0x70,0x60,0x00,0x00,0x00) ;  // 0xF7
chrGenSet2(248,0x30,0x48,0x48,0x30,0x00,0x00,0x00,0x00) ;  // 0xF8
chrGenSet2(249,0x00,0x00,0x00,0x50,0x00,0x00,0x00,0x00) ;  // 0xF9
chrGenSet2(250,0x00,0x00,0x00,0x10,0x00,0x00,0x00,0x00) ;  // 0xFA
chrGenSet2(251,0x10,0x18,0x10,0x10,0x00,0x00,0x00,0x00) ;  // 0xFB
chrGenSet2(252,0x38,0x10,0x30,0x18,0x00,0x00,0x00,0x00) ;  // 0xFC
chrGenSet2(253,0x18,0x20,0x10,0x38,0x00,0x00,0x00,0x00) ;  // 0xFD
chrGenSet2(254,0x00,0x00,0x78,0x78,0x78,0x78,0x00,0x00) ;  // 0xFE
chrGenSet2(255,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00) ;   // 0xFF
}
 
int font5x7rom[] = {
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x3E, 0x5B, 0x4F, 0x5B, 0x3E,
  0x3E, 0x6B, 0x4F, 0x6B, 0x3E,
  0x1C, 0x3E, 0x7C, 0x3E, 0x1C,
  0x18, 0x3C, 0x7E, 0x3C, 0x18,
  0x1C, 0x57, 0x7D, 0x57, 0x1C,
  0x1C, 0x5E, 0x7F, 0x5E, 0x1C,
  0x00, 0x18, 0x3C, 0x18, 0x00,
  0xFF, 0xE7, 0xC3, 0xE7, 0xFF,
  0x00, 0x18, 0x24, 0x18, 0x00,
  0xFF, 0xE7, 0xDB, 0xE7, 0xFF,
  0x30, 0x48, 0x3A, 0x06, 0x0E,
  0x26, 0x29, 0x79, 0x29, 0x26,
  0x40, 0x7F, 0x05, 0x05, 0x07,
  0x40, 0x7F, 0x05, 0x25, 0x3F,
  0x5A, 0x3C, 0xE7, 0x3C, 0x5A,
  0x7F, 0x3E, 0x1C, 0x1C, 0x08,
  0x08, 0x1C, 0x1C, 0x3E, 0x7F,
  0x14, 0x22, 0x7F, 0x22, 0x14,
  0x5F, 0x5F, 0x00, 0x5F, 0x5F,
  0x06, 0x09, 0x7F, 0x01, 0x7F,
  0x00, 0x66, 0x89, 0x95, 0x6A,
  0x60, 0x60, 0x60, 0x60, 0x60,
  0x94, 0xA2, 0xFF, 0xA2, 0x94,
  0x08, 0x04, 0x7E, 0x04, 0x08,
  0x10, 0x20, 0x7E, 0x20, 0x10,
  0x08, 0x08, 0x2A, 0x1C, 0x08,
  0x08, 0x1C, 0x2A, 0x08, 0x08,
  0x1E, 0x10, 0x10, 0x10, 0x10,
  0x0C, 0x1E, 0x0C, 0x1E, 0x0C,
  0x30, 0x38, 0x3E, 0x38, 0x30,
  0x06, 0x0E, 0x3E, 0x0E, 0x06,
  0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x5F, 0x00, 0x00,
  0x00, 0x07, 0x00, 0x07, 0x00,
  0x14, 0x7F, 0x14, 0x7F, 0x14,
  0x24, 0x2A, 0x7F, 0x2A, 0x12,
  0x23, 0x13, 0x08, 0x64, 0x62,
  0x36, 0x49, 0x56, 0x20, 0x50,
  0x00, 0x08, 0x07, 0x03, 0x00,
  0x00, 0x1C, 0x22, 0x41, 0x00,
  0x00, 0x41, 0x22, 0x1C, 0x00,
  0x2A, 0x1C, 0x7F, 0x1C, 0x2A,
  0x08, 0x08, 0x3E, 0x08, 0x08,
  0x00, 0x80, 0x70, 0x30, 0x00,
  0x08, 0x08, 0x08, 0x08, 0x08,
  0x00, 0x00, 0x60, 0x60, 0x00,
  0x20, 0x10, 0x08, 0x04, 0x02,
  0x3E, 0x51, 0x49, 0x45, 0x3E,
  0x00, 0x42, 0x7F, 0x40, 0x00,
  0x72, 0x49, 0x49, 0x49, 0x46,
  0x21, 0x41, 0x49, 0x4D, 0x33,
  0x18, 0x14, 0x12, 0x7F, 0x10,
  0x27, 0x45, 0x45, 0x45, 0x39,
  0x3C, 0x4A, 0x49, 0x49, 0x31,
  0x41, 0x21, 0x11, 0x09, 0x07,
  0x36, 0x49, 0x49, 0x49, 0x36,
  0x46, 0x49, 0x49, 0x29, 0x1E,
  0x00, 0x00, 0x14, 0x00, 0x00,
  0x00, 0x40, 0x34, 0x00, 0x00,
  0x00, 0x08, 0x14, 0x22, 0x41,
  0x14, 0x14, 0x14, 0x14, 0x14,
  0x00, 0x41, 0x22, 0x14, 0x08,
  0x02, 0x01, 0x59, 0x09, 0x06,
  0x3E, 0x41, 0x5D, 0x59, 0x4E,
  0x7C, 0x12, 0x11, 0x12, 0x7C,
  0x7F, 0x49, 0x49, 0x49, 0x36,
  0x3E, 0x41, 0x41, 0x41, 0x22,
  0x7F, 0x41, 0x41, 0x41, 0x3E,
  0x7F, 0x49, 0x49, 0x49, 0x41,
  0x7F, 0x09, 0x09, 0x09, 0x01,
  0x3E, 0x41, 0x41, 0x51, 0x73,
  0x7F, 0x08, 0x08, 0x08, 0x7F,
  0x00, 0x41, 0x7F, 0x41, 0x00,
  0x20, 0x40, 0x41, 0x3F, 0x01,
  0x7F, 0x08, 0x14, 0x22, 0x41,
  0x7F, 0x40, 0x40, 0x40, 0x40,
  0x7F, 0x02, 0x1C, 0x02, 0x7F,
  0x7F, 0x04, 0x08, 0x10, 0x7F,
  0x3E, 0x41, 0x41, 0x41, 0x3E,
  0x7F, 0x09, 0x09, 0x09, 0x06,
  0x3E, 0x41, 0x51, 0x21, 0x5E,
  0x7F, 0x09, 0x19, 0x29, 0x46,
  0x26, 0x49, 0x49, 0x49, 0x32,
  0x03, 0x01, 0x7F, 0x01, 0x03,
  0x3F, 0x40, 0x40, 0x40, 0x3F,
  0x1F, 0x20, 0x40, 0x20, 0x1F,
  0x3F, 0x40, 0x38, 0x40, 0x3F,
  0x63, 0x14, 0x08, 0x14, 0x63,
  0x03, 0x04, 0x78, 0x04, 0x03,
  0x61, 0x59, 0x49, 0x4D, 0x43,
  0x00, 0x7F, 0x41, 0x41, 0x41,
  0x02, 0x04, 0x08, 0x10, 0x20,
  0x00, 0x41, 0x41, 0x41, 0x7F,
  0x04, 0x02, 0x01, 0x02, 0x04,
  0x40, 0x40, 0x40, 0x40, 0x40,
  0x00, 0x03, 0x07, 0x08, 0x00,
  0x20, 0x54, 0x54, 0x78, 0x40,
  0x7F, 0x28, 0x44, 0x44, 0x38,
  0x38, 0x44, 0x44, 0x44, 0x28,
  0x38, 0x44, 0x44, 0x28, 0x7F,
  0x38, 0x54, 0x54, 0x54, 0x18,
  0x00, 0x08, 0x7E, 0x09, 0x02,
  0x18, 0xA4, 0xA4, 0x9C, 0x78,
  0x7F, 0x08, 0x04, 0x04, 0x78,
  0x00, 0x44, 0x7D, 0x40, 0x00,
  0x20, 0x40, 0x40, 0x3D, 0x00,
  0x7F, 0x10, 0x28, 0x44, 0x00,
  0x00, 0x41, 0x7F, 0x40, 0x00,
  0x7C, 0x04, 0x78, 0x04, 0x78,
  0x7C, 0x08, 0x04, 0x04, 0x78,
  0x38, 0x44, 0x44, 0x44, 0x38,
  0xFC, 0x18, 0x24, 0x24, 0x18,
  0x18, 0x24, 0x24, 0x18, 0xFC,
  0x7C, 0x08, 0x04, 0x04, 0x08,
  0x48, 0x54, 0x54, 0x54, 0x24,
  0x04, 0x04, 0x3F, 0x44, 0x24,
  0x3C, 0x40, 0x40, 0x20, 0x7C,
  0x1C, 0x20, 0x40, 0x20, 0x1C,
  0x3C, 0x40, 0x30, 0x40, 0x3C,
  0x44, 0x28, 0x10, 0x28, 0x44,
  0x4C, 0x90, 0x90, 0x90, 0x7C,
  0x44, 0x64, 0x54, 0x4C, 0x44,
  0x00, 0x08, 0x36, 0x41, 0x00,
  0x00, 0x00, 0x77, 0x00, 0x00,
  0x00, 0x41, 0x36, 0x08, 0x00,
  0x02, 0x01, 0x02, 0x04, 0x02,
  0x3C, 0x26, 0x23, 0x26, 0x3C,
  0x1E, 0xA1, 0xA1, 0x61, 0x12,
  0x3A, 0x40, 0x40, 0x20, 0x7A,
  0x38, 0x54, 0x54, 0x55, 0x59,
  0x21, 0x55, 0x55, 0x79, 0x41,
  0x22, 0x54, 0x54, 0x78, 0x42, // a-umlaut
  0x21, 0x55, 0x54, 0x78, 0x40,
  0x20, 0x54, 0x55, 0x79, 0x40,
  0x0C, 0x1E, 0x52, 0x72, 0x12,
  0x39, 0x55, 0x55, 0x55, 0x59,
  0x39, 0x54, 0x54, 0x54, 0x59,
  0x39, 0x55, 0x54, 0x54, 0x58,
  0x00, 0x00, 0x45, 0x7C, 0x41,
  0x00, 0x02, 0x45, 0x7D, 0x42,
  0x00, 0x01, 0x45, 0x7C, 0x40,
  0x7D, 0x12, 0x11, 0x12, 0x7D, // A-umlaut
  0xF0, 0x28, 0x25, 0x28, 0xF0,
  0x7C, 0x54, 0x55, 0x45, 0x00,
  0x20, 0x54, 0x54, 0x7C, 0x54,
  0x7C, 0x0A, 0x09, 0x7F, 0x49,
  0x32, 0x49, 0x49, 0x49, 0x32,
  0x3A, 0x44, 0x44, 0x44, 0x3A, // o-umlaut
  0x32, 0x4A, 0x48, 0x48, 0x30,
  0x3A, 0x41, 0x41, 0x21, 0x7A,
  0x3A, 0x42, 0x40, 0x20, 0x78,
  0x00, 0x9D, 0xA0, 0xA0, 0x7D,
  0x3D, 0x42, 0x42, 0x42, 0x3D, // O-umlaut
  0x3D, 0x40, 0x40, 0x40, 0x3D,
  0x3C, 0x24, 0xFF, 0x24, 0x24,
  0x48, 0x7E, 0x49, 0x43, 0x66,
  0x2B, 0x2F, 0xFC, 0x2F, 0x2B,
  0xFF, 0x09, 0x29, 0xF6, 0x20,
  0xC0, 0x88, 0x7E, 0x09, 0x03,
  0x20, 0x54, 0x54, 0x79, 0x41,
  0x00, 0x00, 0x44, 0x7D, 0x41,
  0x30, 0x48, 0x48, 0x4A, 0x32,
  0x38, 0x40, 0x40, 0x22, 0x7A,
  0x00, 0x7A, 0x0A, 0x0A, 0x72,
  0x7D, 0x0D, 0x19, 0x31, 0x7D,
  0x26, 0x29, 0x29, 0x2F, 0x28,
  0x26, 0x29, 0x29, 0x29, 0x26,
  0x30, 0x48, 0x4D, 0x40, 0x20,
  0x38, 0x08, 0x08, 0x08, 0x08,
  0x08, 0x08, 0x08, 0x08, 0x38,
  0x2F, 0x10, 0xC8, 0xAC, 0xBA,
  0x2F, 0x10, 0x28, 0x34, 0xFA,
  0x00, 0x00, 0x7B, 0x00, 0x00,
  0x08, 0x14, 0x2A, 0x14, 0x22,
  0x22, 0x14, 0x2A, 0x14, 0x08,
  0x55, 0x00, 0x55, 0x00, 0x55, // #176 (25% block) missing in old code
  0xAA, 0x55, 0xAA, 0x55, 0xAA, // 50% block
  0xFF, 0x55, 0xFF, 0x55, 0xFF, // 75% block
  0x00, 0x00, 0x00, 0xFF, 0x00,
  0x10, 0x10, 0x10, 0xFF, 0x00,
  0x14, 0x14, 0x14, 0xFF, 0x00,
  0x10, 0x10, 0xFF, 0x00, 0xFF,
  0x10, 0x10, 0xF0, 0x10, 0xF0,
  0x14, 0x14, 0x14, 0xFC, 0x00,
  0x14, 0x14, 0xF7, 0x00, 0xFF,
  0x00, 0x00, 0xFF, 0x00, 0xFF,
  0x14, 0x14, 0xF4, 0x04, 0xFC,
  0x14, 0x14, 0x17, 0x10, 0x1F,
  0x10, 0x10, 0x1F, 0x10, 0x1F,
  0x14, 0x14, 0x14, 0x1F, 0x00,
  0x10, 0x10, 0x10, 0xF0, 0x00,
  0x00, 0x00, 0x00, 0x1F, 0x10,
  0x10, 0x10, 0x10, 0x1F, 0x10,
  0x10, 0x10, 0x10, 0xF0, 0x10,
  0x00, 0x00, 0x00, 0xFF, 0x10,
  0x10, 0x10, 0x10, 0x10, 0x10,
  0x10, 0x10, 0x10, 0xFF, 0x10,
  0x00, 0x00, 0x00, 0xFF, 0x14,
  0x00, 0x00, 0xFF, 0x00, 0xFF,
  0x00, 0x00, 0x1F, 0x10, 0x17,
  0x00, 0x00, 0xFC, 0x04, 0xF4,
  0x14, 0x14, 0x17, 0x10, 0x17,
  0x14, 0x14, 0xF4, 0x04, 0xF4,
  0x00, 0x00, 0xFF, 0x00, 0xF7,
  0x14, 0x14, 0x14, 0x14, 0x14,
  0x14, 0x14, 0xF7, 0x00, 0xF7,
  0x14, 0x14, 0x14, 0x17, 0x14,
  0x10, 0x10, 0x1F, 0x10, 0x1F,
  0x14, 0x14, 0x14, 0xF4, 0x14,
  0x10, 0x10, 0xF0, 0x10, 0xF0,
  0x00, 0x00, 0x1F, 0x10, 0x1F,
  0x00, 0x00, 0x00, 0x1F, 0x14,
  0x00, 0x00, 0x00, 0xFC, 0x14,
  0x00, 0x00, 0xF0, 0x10, 0xF0,
  0x10, 0x10, 0xFF, 0x10, 0xFF,
  0x14, 0x14, 0x14, 0xFF, 0x14,
  0x10, 0x10, 0x10, 0x1F, 0x00,
  0x00, 0x00, 0x00, 0xF0, 0x10,
  0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
  0xF0, 0xF0, 0xF0, 0xF0, 0xF0,
  0xFF, 0xFF, 0xFF, 0x00, 0x00,
  0x00, 0x00, 0x00, 0xFF, 0xFF,
  0x0F, 0x0F, 0x0F, 0x0F, 0x0F,
  0x38, 0x44, 0x44, 0x38, 0x44,
  0xFC, 0x4A, 0x4A, 0x4A, 0x34, // sharp-s or beta
  0x7E, 0x02, 0x02, 0x06, 0x06,
  0x02, 0x7E, 0x02, 0x7E, 0x02,
  0x63, 0x55, 0x49, 0x41, 0x63,
  0x38, 0x44, 0x44, 0x3C, 0x04,
  0x40, 0x7E, 0x20, 0x1E, 0x20,
  0x06, 0x02, 0x7E, 0x02, 0x02,
  0x99, 0xA5, 0xE7, 0xA5, 0x99,
  0x1C, 0x2A, 0x49, 0x2A, 0x1C,
  0x4C, 0x72, 0x01, 0x72, 0x4C,
  0x30, 0x4A, 0x4D, 0x4D, 0x30,
  0x30, 0x48, 0x78, 0x48, 0x30,
  0xBC, 0x62, 0x5A, 0x46, 0x3D,
  0x3E, 0x49, 0x49, 0x49, 0x00,
  0x7E, 0x01, 0x01, 0x01, 0x7E,
  0x2A, 0x2A, 0x2A, 0x2A, 0x2A,
  0x44, 0x44, 0x5F, 0x44, 0x44,
  0x40, 0x51, 0x4A, 0x44, 0x40,
  0x40, 0x44, 0x4A, 0x51, 0x40,
  0x00, 0x00, 0xFF, 0x01, 0x03,
  0xE0, 0x80, 0xFF, 0x00, 0x00,
  0x08, 0x08, 0x6B, 0x6B, 0x08,
  0x36, 0x12, 0x36, 0x24, 0x36,
  0x06, 0x0F, 0x09, 0x0F, 0x06,
  0x00, 0x00, 0x18, 0x18, 0x00,
  0x00, 0x00, 0x10, 0x10, 0x00,
  0x30, 0x40, 0xFF, 0x01, 0x01,
  0x00, 0x1F, 0x01, 0x01, 0x1E,
  0x00, 0x19, 0x1D, 0x17, 0x12,
  0x00, 0x3C, 0x3C, 0x3C, 0x3C,
  0x00, 0x00, 0x00, 0x00, 0x00  // #255 NBSP
};
//------------------------------------------------------------------------------------------------------

// character generator 6571AP4
#define Rows 15 
#define Cols 11 

// character generator 6x8
//#define Rows 9 
//#define Cols 6 

// chrGen 5x7
//#define Rows 5 
//#define Cols 8 
 
uint8_t prom6571AP4[128][16] ;

void chrGenSet(int number, int r0,int r1,int r2,int r3,int r4,int r5,int r6,int r7,int r8, int r9,int r10,int r11,int r12, int r13,int r14,int r15) {
  prom6571AP4[number][ 0]=(uint8_t) r0  ; prom6571AP4[number][ 1]=(uint8_t) r1  ;
  prom6571AP4[number][ 2]=(uint8_t) r2  ; prom6571AP4[number][ 3]=(uint8_t) r3  ;
  prom6571AP4[number][ 4]=(uint8_t) r4  ; prom6571AP4[number][ 5]=(uint8_t) r5  ;
  prom6571AP4[number][ 6]=(uint8_t) r6  ; prom6571AP4[number][ 7]=(uint8_t) r7  ; 
  prom6571AP4[number][ 8]=(uint8_t) r8  ; prom6571AP4[number][ 9]=(uint8_t) r9  ;
  prom6571AP4[number][10]=(uint8_t) r10 ; prom6571AP4[number][11]=(uint8_t) r11 ;
  prom6571AP4[number][12]=(uint8_t) r12 ; prom6571AP4[number][13]=(uint8_t) r13 ;
  prom6571AP4[number][14]=(uint8_t) r14 ; prom6571AP4[number][15]=(uint8_t) r15 ;
  }

void init6571AP4(){
  chrGenSet(  0,0000,0000,0000,0000,0X30,0X4A,0X44,0X4A,0X31,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(  1,0000,0000,0000,0000,0X3C,0X22,0X3C,0X22,0X22,0X3C,0X20,0X20,0X40,0000,0000,0000) ; 
  chrGenSet(  2,0000,0000,0000,0000,0000,0X61,0X12,0X14,0X18,0X10,0X30,0X30,0X30,0000,0000,0000) ; 
  chrGenSet(  3,0X30,0X48,0X40,0X40,0X20,0X30,0X48,0X48,0X30,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(  4,0000,0000,0X18,0X20,0X40,0X78,0X40,0X20,0X18,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(  5,0000,0000,0000,0000,0X16,0X0E,0X10,0X20,0X40,0X40,0X38,0X04,0X0C,0000,0000,0000) ; 
  chrGenSet(  6,0000,0X2C,0X52,0X12,0X12,0X12,0X02,0X02,0X02,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(  7,0X18,0X24,0X42,0X42,0X7E,0X42,0X42,0X24,0X18,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(  8,0000,0000,0000,0X40,0X40,0X40,0X40,0X48,0X30,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(  9,0000,0000,0000,0000,0000,0000,0X40,0X48,0X50,0X60,0X50,0X4A,0X44,0000,0000,0000) ; 
  chrGenSet( 10,0X40,0X20,0X10,0X10,0X10,0X10,0X18,0X24,0X42,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 11,0000,0X48,0X48,0X48,0X48,0X74,0X40,0X40,0X40,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 12,0000,0000,0000,0X62,0X22,0X24,0X28,0X30,0X20,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 13,0X08,0X1C,0X20,0X18,0X20,0X40,0X3C,0X02,0X06,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 14,0000,0000,0000,0X18,0X24,0X42,0X42,0X24,0X18,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 15,0000,0000,0000,0X3F,0X54,0X14,0X14,0X14,0X14,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 16,0000,0000,0000,0000,0X18,0X24,0X42,0X42,0X64,0X58,0X40,0X40,0X40,0000,0000,0000) ; 
  chrGenSet( 17,0000,0000,0000,0X1F,0X28,0X44,0X42,0X24,0X18,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 18,0000,0000,0000,0X3F,0X48,0X08,0X08,0X08,0X08,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 19,0000,0000,0000,0X62,0X24,0X24,0X24,0X24,0X18,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 20,0X08,0X1C,0X2A,0X2A,0X2A,0X1C,0X08,0X08,0X08,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 21,0000,0000,0000,0000,0X62,0X14,0X08,0X14,0X23,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 22,0000,0000,0000,0000,0X08,0X49,0X2A,0X2A,0X2A,0X1C,0X08,0X08,0X08,0000,0000,0000) ; 
  chrGenSet( 23,0000,0000,0000,0X22,0X41,0X49,0X49,0X49,0X36,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 24,0000,0X1C,0X22,0X41,0X41,0X41,0X22,0X22,0X63,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 25,0X1F,0X10,0X10,0X10,0X10,0X10,0X50,0X30,0X10,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 26,0000,0000,0X04,0X02,0X7F,0X02,0X04,0000,0000,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 27,0000,0000,0X10,0X20,0X7F,0X20,0X10,0000,0000,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 28,0X08,0X1C,0X2A,0X08,0X08,0X08,0X08,0X08,0X08,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 29,0000,0000,0X08,0000,0X7F,0000,0X08,0000,0000,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 30,0X7F,0X20,0X10,0X08,0X06,0X08,0X10,0X20,0X7F,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 31,0000,0X30,0X49,0X06,0X30,0X49,0X06,0000,0000,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 32,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 33,0X08,0X08,0X08,0X08,0X08,0X08,0000,0000,0X08,0000,0000,0000,0000,0000,0000,0000) ;
  chrGenSet( 34,0X12,0X12,0X12,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 35,0X14,0X14,0X14,0X7F,0X14,0X7F,0X14,0X14,0X14,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 36,0X08,0X3F,0X48,0X48,0X3E,0X09,0X09,0X7E,0X08,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 37,0X20,0X51,0X02,0X04,0X08,0X10,0X22,0X45,0X02,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 38,0X38,0X44,0X44,0X28,0X10,0X29,0X46,0X46,0X39,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 39,0X20,0X20,0X40,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 40,0X08,0X10,0X20,0X20,0X20,0X20,0X20,0X10,0X08,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 41,0X08,0X04,0X02,0X02,0X02,0X02,0X02,0X04,0X08,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 42,0X08,0X49,0X2A,0X1C,0X7F,0X1C,0X2A,0X49,0X08,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 43,0000,0X08,0X08,0X08,0X7F,0X08,0X08,0X08,0000,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 44,0000,0000,0000,0000,0000,0000,0000,0000,0000,0X30,0X10,0X10,0X20,0000,0000,0000) ; 
  chrGenSet( 45,0000,0000,0000,0000,0X7F,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 46,0000,0000,0000,0000,0000,0000,0000,0000,0X10,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 47,0000,0X01,0X02,0X04,0X08,0X10,0X20,0X40,0000,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 48,0X3E,0X41,0X43,0X45,0X49,0X51,0X61,0X41,0X3E,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 49,0X08,0X18,0X08,0X08,0X08,0X08,0X08,0X08,0X3E,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 50,0X3E,0X41,0X01,0X02,0X0C,0X10,0X20,0X40,0X7F,0000,0000,0000,0000,0000,0000,0000) ; 
  //chrGenSet( 51,0X3E,0X01,0X01,0X01,0X1E,0X01,0X01,0X41,0X1E,0000,0000,0000,0000,0000,0000,0000) ;
  chrGenSet( 51,0X3E,0X01,0X01,0X01,0X1E,0X01,0X01,0X01,0X3E,0000,0000,0000,0000,0000,0000,0000) ;
  chrGenSet( 52,0X02,0X06,0X0A,0X12,0X22,0X7F,0X02,0X02,0X02,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 53,0X7F,0X40,0X40,0X40,0X7E,0X01,0X01,0X41,0X3E,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 54,0X3E,0X41,0X40,0X40,0X7E,0X41,0X41,0X41,0X3E,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 55,0X7F,0X41,0X02,0X04,0X08,0X10,0X10,0X10,0X10,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 56,0X3E,0X41,0X41,0X41,0X3E,0X41,0X41,0X41,0X3E,0000,0000,0000,0000,0000,0000,0000) ; 
  //chrGenSet( 57,0X3F,0X41,0X41,0X41,0X3F,0X01,0X01,0X41,0X3E,0000,0000,0000,0000,0000,0000,0000) ;
  chrGenSet( 57,0X3C,0X41,0X41,0X41,0X3F,0X01,0X01,0X41,0X3E,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 58,0000,0000,0X20,0000,0000,0000,0X20,0000,0000,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 59,0000,0000,0000,0000,0X20,0000,0000,0000,0000,0X30,0X10,0X10,0X20,0000,0000,0000) ; 
  chrGenSet( 60,0X04,0X08,0X10,0X20,0X40,0X20,0X10,0X08,0X04,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 61,0000,0000,0000,0X7F,0000,0X7F,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 62,0X10,0X08,0X04,0X02,0X01,0X02,0X04,0X08,0X10,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 63,0X3E,0X41,0X41,0X02,0X04,0X08,0X08,0000,0X08,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 64,0X3E,0X41,0X41,0X4D,0X55,0X5E,0X40,0X40,0X3E,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 65,0X1C,0X22,0X41,0X41,0X7F,0X41,0X41,0X41,0X41,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 66,0X7E,0X21,0X21,0X21,0X3E,0X21,0X21,0X21,0X7E,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 67,0X1E,0X21,0X40,0X40,0X40,0X40,0X40,0X21,0X1E,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 68,0X7E,0X41,0X41,0X41,0X41,0X41,0X41,0X41,0X7E,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 69,0X7F,0X40,0X40,0X40,0X78,0X40,0X40,0X40,0X7F,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 70,0X7F,0X40,0X40,0X40,0X78,0X40,0X40,0X40,0X40,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 71,0X1E,0X21,0X40,0X40,0X40,0X47,0X41,0X21,0X1E,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 72,0X41,0X41,0X41,0X41,0X7F,0X41,0X41,0X41,0X41,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 73,0X3E,0X08,0X08,0X08,0X08,0X08,0X08,0X08,0X3E,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 74,0X1F,0X04,0X04,0X04,0X04,0X04,0X04,0X44,0X38,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 75,0X41,0X42,0X44,0X48,0X70,0X48,0X44,0X42,0X41,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 76,0X40,0X40,0X40,0X40,0X40,0X40,0X40,0X40,0X7F,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 77,0X41,0X63,0X55,0X49,0X49,0X41,0X41,0X41,0X41,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 78,0X41,0X61,0X51,0X49,0X45,0X43,0X41,0X41,0X41,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 79,0X1C,0X22,0X41,0X41,0X41,0X41,0X41,0X22,0X1C,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 80,0X7E,0X41,0X41,0X41,0X7E,0X40,0X40,0X40,0X40,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 81,0X1C,0X22,0X41,0X41,0X41,0X41,0X45,0X22,0X1D,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 82,0X7E,0X41,0X41,0X41,0X7E,0X48,0X44,0X42,0X41,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 83,0X3E,0X41,0X40,0X40,0X3E,0X01,0X01,0X41,0X3E,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 84,0X7F,0X08,0X08,0X08,0X08,0X08,0X08,0X08,0X08,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 85,0X41,0X41,0X41,0X41,0X41,0X41,0X41,0X41,0X3E,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 86,0X41,0X41,0X41,0X41,0X41,0X41,0X22,0X14,0X08,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 87,0X41,0X41,0X41,0X49,0X49,0X49,0X55,0X63,0X41,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 88,0X41,0X41,0X22,0X14,0X08,0X14,0X22,0X41,0X41,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 89,0X41,0X41,0X22,0X14,0X08,0X08,0X08,0X08,0X08,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 90,0X7F,0X01,0X02,0X04,0X08,0X10,0X20,0X40,0X7F,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 91,0X1E,0X10,0X10,0X10,0X10,0X10,0X10,0X10,0X1E,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 92,0000,0X40,0X20,0X10,0X08,0X04,0X02,0X01,0000,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 93,0X3C,0X04,0X04,0X04,0X04,0X04,0X04,0X04,0X3C,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 94,0X3E,0X41,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 95,0000,0000,0000,0000,0000,0000,0000,0000,0X7F,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 96,0X02,0X02,0X01,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 97,0000,0000,0000,0X1E,0X22,0X42,0X42,0X46,0X3A,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 98,0X40,0X40,0X40,0X5C,0X62,0X42,0X42,0X62,0X5C,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet( 99,0000,0000,0000,0X3C,0X42,0X40,0X40,0X42,0X3C,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(100,0X02,0X02,0X02,0X3A,0X42,0X42,0X42,0X46,0X3A,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(101,0000,0000,0000,0X3C,0X42,0X42,0X7E,0X40,0X3E,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(102,0X0C,0X12,0X10,0X10,0X7C,0X10,0X10,0X10,0X10,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(103,0000,0000,0000,0000,0X3A,0X46,0X42,0X42,0X42,0X3A,0X02,0X42,0X3C,0000,0000,0000) ; 
  chrGenSet(104,0X40,0X40,0X40,0X58,0X64,0X42,0X42,0X42,0X42,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(105,0000,0X08,0000,0X18,0X08,0X08,0X08,0X08,0X08,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(106,0000,0000,0000,0000,0X02,0X02,0X02,0X02,0X02,0X02,0X02,0X42,0X3C,0000,0000,0000) ; 
  chrGenSet(107,0X40,0X40,0X40,0X44,0X48,0X70,0X48,0X44,0X42,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(108,0X10,0X10,0X10,0X10,0X10,0X10,0X10,0X10,0X10,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(109,0000,0000,0000,0X76,0X49,0X49,0X49,0X49,0X49,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(110,0000,0000,0000,0X5C,0X62,0X42,0X42,0X42,0X42,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(111,0000,0000,0000,0X3C,0X42,0X42,0X42,0X42,0X3C,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(112,0000,0000,0000,0000,0X5C,0X62,0X42,0X42,0X42,0X5C,0X40,0X40,0X40,0000,0000,0000) ; 
  chrGenSet(113,0000,0000,0000,0000,0X3A,0X42,0X42,0X42,0X46,0X3A,0X02,0X02,0X02,0000,0000,0000) ; 
  chrGenSet(114,0000,0000,0000,0X5C,0X62,0X40,0X40,0X40,0X40,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(115,0000,0000,0000,0X3C,0X42,0X30,0X0C,0X42,0X3C,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(116,0000,0X10,0X10,0X7C,0X10,0X10,0X10,0X12,0X0C,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(117,0000,0000,0000,0X42,0X42,0X42,0X42,0X42,0X3C,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(118,0000,0000,0000,0X44,0X44,0X44,0X44,0X28,0X10,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(119,0000,0000,0000,0X41,0X49,0X49,0X49,0X49,0X36,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(120,0000,0000,0000,0X42,0X24,0X18,0X18,0X24,0X42,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(121,0000,0000,0000,0000,0X42,0X42,0X42,0X42,0X46,0X3A,0X02,0X42,0X3C,0000,0000,0000) ; 
  chrGenSet(122,0000,0000,0000,0X7E,0X04,0X08,0X10,0X20,0X7E,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(123,0X0E,0X10,0X10,0X10,0X20,0X10,0X10,0X10,0X0E,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(124,0X08,0X08,0X08,0000,0000,0X08,0X08,0X08,0000,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(125,0X38,0X04,0X04,0X04,0X02,0X04,0X04,0X04,0X38,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(126,0X30,0X49,0X06,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000,0000) ; 
  chrGenSet(127,0X7F,0X7F,0X7F,0X7F,0X7F,0X7F,0X7F,0X7F,0X7F,0000,0000,0000,0000,0000,0000,0000) ; 
  }

void dot(int x, int y, int v){
  int xColor ;
  // if( (x+y)&1){ v=0 ; } else { v=1 ; }
  if( v != 0) { 
    xColor=chrColor ;
    } 
   else {
    xColor=chrBackground ;
    }
  Rectf(x,y,  xs, ys, xColor) ;
  }

void drawChr5x7(char index,int x, int y){
  int xColor ;      
  if(LCDOn!=1) return ;
  for(int row=0 ; row<Rows ; row++){
    int b=font5x7rom[5*index+row] ;
    for(int col=0 ; col<Cols ; col++){
      dot(ys*(y+row),xs*(x+col), b & (1<<col) ) ;
      }  
    }
  }

void drawChr6x8(char index,int x, int y){
  int xColor ;      
  if(LCDOn!=1) return ;
  index &= 0x7F ;
  for(int row=0 ; row<8 ; row++){
    int b=chr6x8rom[(int)index][row] ;
    for(int col=0 ; col<6 ; col++){
      dot(ys*(y+col),xs*(x+row), b & (1<<(col+2)) ) ;
      }  
    }
  }

void drawChr6571AP4x(char index,int x, int y){
  int xColor ;      
  if(LCDOn!=1) return ;
  index &= 0x7F ;
  for(int row=0 ; row<Rows ; row++){
    int b=prom6571AP4[(int)index][row] ;
    for(int col=0 ; col<Cols ; col++){
      dot(ys*(y+col),xs*(x+row),b&(1<<(6-col)) ) ; 
      }  
    }
  }

void drawChr6571AP4y(char index,int x, int y){
  int xColor ;      
  if(LCDOn!=1) return ;
  index &= 0x7F ;
  for(int row=0 ; row<Rows ; row++){
    int b=prom6571AP4[(int)index][row] ;
    for(int col=0 ; col<Cols ; col++){
      //if( (b&(1<<(6-col))) != 0) { 
      if( (b&(1<<(col))) != 0) { 

        xColor=chrColor ;
        } 
       else {
        xColor=chrBackground;
        }
      Rectf(xs*(x+row), ys*(y-col), xs, ys, xColor) ;
      }  
    }
  }  

void printX(char *cp,int x, int y){
  register char c;
  if(LCDOn!=1) return ;
   while ( (c = *(cp++)) ) { 
    drawChr6571AP4x(c,x,y) ;
    x+=Cols*xs ;
    }
  }

void printY(char *cp,int x, int y){
  register char c;
  if(LCDOn!=1) return ;
   while ( (c = *(cp++)) ) { 
    drawChr6571AP4y(c,x,y) ;
    y-=Cols*ys ;
    }
  }  

void LCD_putc(char c){
  if(LCDOn!=1) return ;
  drawChr6571AP4y(c,cursorX,cursorY) ;
  //drawChr6x8(c,cursorX,cursorY) ;
  //drawChr5x7(c,cursorX,cursorY) ;
  cursorY+=Cols*xs ;
  }

void LCD_print(char *cp){
  register char c;
  if(LCDOn!=1) return ;
  while ( (c = *(cp++)) ) { 
    LCD_putc(c) ;
    }
  }  

//------------------------------------------------------------------------------------------------------

void abort2(){
  printf("\nabort()...\n") ;
  while(1){}
  }

#define tftWidth 480
#define tftHeight 320

void tftClear(int color){
  LCD_Clear(color) ;
  }

void tftRectf(int x, int y, int w, int h , int c){
  Rectf(319-y-h,x,h,w,c) ;
  }

void tftDot(int x, int y , int c){
  Rectf(320-y-1,x,1,1,c) ;
  }  

void colorTest(){
  for(int x=0 ; x<256 ; x++){
    for(int y=0 ; y<256 ; y++){
      RectfOld(x,y,1,1,(x<<8)|y) ;
      }
    }
  abort2() ;  
  }

void tftLine(int xx0, int yy0, int xx1 , int yy1, int color){
  bresenham1(319-yy0, xx0, 319-yy1 , xx1, color) ;
  }

void tftChr(int x, int y, char ch){
  drawChr6571AP4y(ch,319-y-Rows-1,x+Cols) ;
  }

void tftPutc(char c){
  tftChr(cursorX,cursorY,c) ;
  cursorX += Cols*xs ;
  }

void tftPrint(char *cp){
  register char c;
  if(LCDOn!=1) return ;
  while ( (c = *(cp++)) ) { 
    tftPutc(c) ;
    }
  }  

void tftBlank(){
  if(LCDOn!=1) return ;
  tftPutc(' ') ; 
  }

void tftHome(){
  if(LCDOn!=1) return ;
  cursorX=120 ;
  cursorY=170 ;
  }

void tftCrlf(){
  if(LCDOn!=1) return ;
  cursorX+=Rows*ys ;
  cursorY=170 ;
  }

void tftDecout(int k){
  if(LCDOn!=1) return ;
  tftPutc( ((k/1000) % 10)+48 ) ;
  tftPutc( ((k/100) % 10)+48 ) ;
  tftPutc( ((k/10) % 10)+48 ) ;
  tftPutc( (k % 10)+48 ) ;
  tftPutc(32) ;
  }

void tftDecout2(int k){
  if(LCDOn!=1) return ;
  tftPutc( ((k/10) % 10)+48 ) ;
  tftPutc( (k % 10)+48 ) ;
  }

void tftHexOut(uint8_t v){
  if(LCDOn!=1) return ;
  v &=0b00001111 ;
  if (v<=9) { tftPutc('0'+v) ; } 
    else { tftPutc(v+'A'-10) ; } ;
  }

void tftByteOut(uint8_t v){
  if(LCDOn!=1) return ;
  tftHexOut(v>>4) ; 
  tftHexOut(v) ; 
  }

void tftWordOut(uint16_t v){
  if(LCDOn!=1) return ;
  tftByteOut(v>>8) ; 
  tftByteOut(v) ; 
  }

void test1(){
  tftRectf(50,10,30,10,0xFFFF) ;
  tftDot(50,30,0xFFFF) ;
  tftLine(50,50,70,70,0xFFFF) ;
  
  tftLine(100,100,120,100,0xFFF) ;
  tftLine(100,100,100,120,0xFFFF) ;
  tftChr(100,100,'B') ;

  int x=10 ; int y=200 ; int chr='A' ; while(x<400){
    tftChr(x,y,chr) ;
    x+=Cols ; chr++ ;
  
    }
  cursorX=200 ; cursorY=100 ; tftPrint("Hello World!") ;
  abort2() ;
  }

//------------------------------------------------------------------------------------------------------

void testSin(){
  int xLast=0 ; 
  int yLast=0 ;
  bool first=1 ;
  for(int x=0 ; x<480 ; x++){
    int y=160+150*sin(2*M_PI*x/100.0) ;
    if(!first){ tftLine(xLast,yLast,x,y,0xFFFF) ;}
    xLast=x ;
    yLast=y ;
    first=0 ;
    }

  }

//------------------------------------------------------------------------------------------------------

void tftSetup(){
    stdio_init_all();
    gpio_init(TFTD0);
    gpio_set_dir(TFTD0, GPIO_OUT);

     gpio_init(TFTD1);
    gpio_set_dir(TFTD1, GPIO_OUT);

     gpio_init(TFTD2);
    gpio_set_dir(TFTD2, GPIO_OUT);

     gpio_init(TFTD3);
    gpio_set_dir(TFTD3, GPIO_OUT);

     gpio_init(TFTD4);
    gpio_set_dir(TFTD4, GPIO_OUT);

     gpio_init(TFTD5);
    gpio_set_dir(TFTD5, GPIO_OUT);

     gpio_init(TFTD6);
    gpio_set_dir(TFTD6, GPIO_OUT);

     gpio_init(TFTD7);
    gpio_set_dir(TFTD7, GPIO_OUT);

    gpio_init(TFTCS);
    gpio_set_dir(TFTCS, GPIO_OUT);

     gpio_init(TFTRS);
    gpio_set_dir(TFTRS, GPIO_OUT);

     gpio_init(TFTWR);
    gpio_set_dir(TFTWR, GPIO_OUT);

     gpio_init(TFTRD);
    gpio_set_dir(TFTRD, GPIO_OUT);

     gpio_init(TFTRST);
    gpio_set_dir(TFTRST, GPIO_OUT);

    //gpio_init(TFTreset);
    //gpio_set_dir(TFTreset, GPIO_OUT);

    puts("Hello, world!");

    init6571AP4() ;
    getFont6x8() ;

      //gpio_put2(TFTWR, 0);
      //sleep_us(5) ;
      //gpio_put2(TFTWR, 1);
     // V_line(10,10,100,123) ;
     gpio_put2(TFTCS, 1);
     gpio_put2(TFTRS, 1);
     gpio_put2(TFTRD, 1);
     gpio_put2(TFTWR, 1);


     LCDinit2() ;
     LCD_Clear(0x0000);

     //colorTest() ;
/*
     Rectf(10,10,100,100,0xF800) ;
     Rectf(10,110,100,100,0x07E0) ;
     Rectf(10,210,100,100,0x001F) ;
     RectfOld(110,10,100,100,0xF800) ;
     RectfOld(110,110,100,100,0x07E0) ;
     RectfOld(110,210,100,100,0x001F) ;

     tftLine(0,0,320,320,0xF800) ; 
     tftLine(0,320,320,0,0xF800) ; 
*/
     //abort2() ;
     //test1() ;
     //testSin() ;
     //abort2() ;

  //    Lcd_Init() ;
  }

void brokenLine(int xx0, int yy0, int xx1 , int yy1, int m, int color){
 int x,y,dx,dy,d,xss,yss ;
 int toggle,toggleCnt ;

// tftLine(xx0,yy0,xx1,yy1,color) ;
// return ;
 
  if(tftOn!=1) return ;
  x=xx0 ; y=yy0 ;
  toggleCnt=0 ;
  toggle=1 ;
  tftDot(x,y,color) ;
  dy=yy1-yy0 ; if (dy<0) {dy=-dy ; }
  dx=xx1-xx0 ; if (dx<0) {dx=-dx ; } 
  d=dx-dy ;
  if (xx1>xx0) { xss=1 ; } else { xss=-1 ; } ;
  if (yy1>yy0) { yss=1 ; } else { yss=-1 ; } ;
  while ( (x!=xx1) || (y!=yy1) ) {
    if (d>=0){ x += xss ; d -=dy ; }
    if (d<0) { y+=yss ; d+=dx ; }
    if(toggle){  tftDot(x,y,color) ; }
    toggleCnt++ ;
    if(toggleCnt>=m){ toggleCnt=0 ; toggle=!toggle ; }
    }     
    
  }